$typecheck ON
' $INCLUDE "RAPIDQ.INC"
$INCLUDE "RAPIDQ2.INC"
$INCLUDE <GL\QGL.inc>

CONST LF = CHR$(10)

DECLARE SUB FormCreate
DECLARE SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER)
DECLARE SUB FormMouseDown (Button%, X%, Y%, Shift%)
DECLARE SUB FormMouseMove (X%, Y%, Shift%)
DECLARE SUB FormMouseUp(Button%, X%, Y%, Shift%)
DECLARE SUB FormSize
DECLARE SUB FormClose
DECLARE sub meshbuilder
DECLARE sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
DECLARE sub setrendermode
DECLARE sub setvisual(iw as integer, ih as integer)
DECLARE SUB ObjNumberChange
DECLARE SUB TexNumberChange
DECLARE SUB RndNumberChange
DECLARE SUB AmbNumberChange
DECLARE SUB ViewMesh
DECLARE SUB InitMesh

DECLARE SUB EditObjForm
DECLARE SUB CloseObjForm

DECLARE SUB EditTexForm
DECLARE SUB CloseTexForm

DECLARE SUB EditRndForm
DECLARE SUB CloseRndForm

DECLARE SUB EditAmbForm
DECLARE SUB CloseAmbForm

DECLARE SUB LoadObjFile
DECLARE SUB SaveObjFile
DECLARE SUB ObjLoad
DECLARE SUB Obj1Save
DECLARE SUB Obj2Save

DECLARE SUB SavePrjFile
DECLARE SUB FilePrjExport

DIM CONTADOR AS INTEGER, CONTADOR2 AS INTEGER, RSFXCount AS INTEGER, FOGRGB AS INTEGER, WATERRGB AS INTEGER, X AS INTEGER, Y AS INTEGER
DIM MustWidth%
DIM MustHeight%


$define PAN    1
$define ROTATE 2
$define ZOOM   3

defint mx,my,dx,dy
dim trans(3) as single
dim rotat(2) as single

DEFINT state = 0

DIM meshList as glInt

DIM GL AS QGL
  GL.bpp = 32
    GL.DepthBits = 32
'-- user interface here 


$RESOURCE ICO_CARN AS "E:\CARN2\CARN2.ICO"
Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (lpszName As long, hModule As Long, dwFlags As Long) As Long


create Form as QFORM'EX
    IcoHandle = ICO_CARN
  caption       = "3D View"
  center
'  width         = 256
  width         = 360
'  height        = 256
    Height = 256+4+18+20+2+22+4
  onresize      = FormSize
    onpaint       = FormSize
'  onpaint       = meshbuilder
'  onshow        = FormCreate
  onshow        = meshbuilder
  onmouseup     = FormMouseUp
  onmousedown   = FormMouseDown
  onmousemove   = FormMouseMove
'  onmousewheel  = FormMouseWheel
  onkeydown     = FormKeyDown
  visible=False
end create
' form.showmodal

declare sub play (length AS INTEGER, wavdata AS STRING)
declare sub saveWav (fn AS STRING, length AS INTEGER, wavdata AS STRING)
declare sub loadWav (fn AS STRING, SoundType AS INTEGER)

dim soundstream as qmemorystream
DIM WavFile AS QFileStream
DIM SaveWavDialog AS QFileDialog
DIM LoadWavDialog AS QOpenDialog
     
DIM SaveDialog AS QFileDialog
DIM OpenDialog AS QOpenDialog

' Color edit window
' Based on Color Palette for Rapid-Q by William Yu
DECLARE SUB ColorChange
DECLARE SUB RGBPaint

DECLARE SUB FogColorChange
DECLARE SUB FogNumberChange
DECLARE SUB FogYBeginChange
DECLARE SUB FogTranspChange
DECLARE SUB FogFLimitChange
DECLARE SUB FogRGBPaint

DECLARE SUB WaterColorChange
DECLARE SUB WaterNumberChange
DECLARE SUB WaterWlevelChange
DECLARE SUB WaterTranspChange
DECLARE SUB WaterTindexChange
DECLARE SUB WaterRGBPaint
DECLARE SUB WaterTexPaint

DECLARE SUB TexPaint

DECLARE SUB TableNumberChange
DECLARE SUB TableAVolumeChange
DECLARE SUB TableRSFXCountChange
DECLARE SUB TableRNumberChange(Z AS INTEGER)
DECLARE SUB TableRVolumeChange(Z AS INTEGER)
DECLARE SUB TableRFreqChange(Z AS INTEGER)
DECLARE SUB TableREnvirChange(Z AS INTEGER)

DECLARE SUB TableRNumberChange0
DECLARE SUB TableRVolumeChange0
DECLARE SUB TableRFreqChange0
DECLARE SUB TableREnvirChange0

DECLARE SUB TableRNumberChange1
DECLARE SUB TableRVolumeChange1
DECLARE SUB TableRFreqChange1
DECLARE SUB TableREnvirChange1

DECLARE SUB TableRNumberChange2
DECLARE SUB TableRVolumeChange2
DECLARE SUB TableRFreqChange2
DECLARE SUB TableREnvirChange2

DECLARE SUB TableRNumberChange3
DECLARE SUB TableRVolumeChange3
DECLARE SUB TableRFreqChange3
DECLARE SUB TableREnvirChange3

DECLARE SUB TableRNumberChange4
DECLARE SUB TableRVolumeChange4
DECLARE SUB TableRFreqChange4
DECLARE SUB TableREnvirChange4

DECLARE SUB TableRNumberChange5
DECLARE SUB TableRVolumeChange5
DECLARE SUB TableRFreqChange5
DECLARE SUB TableREnvirChange5

DECLARE SUB TableRNumberChange6
DECLARE SUB TableRVolumeChange6
DECLARE SUB TableRFreqChange6
DECLARE SUB TableREnvirChange6

DECLARE SUB TableRNumberChange7
DECLARE SUB TableRVolumeChange7
DECLARE SUB TableRFreqChange7
DECLARE SUB TableREnvirChange7

DECLARE SUB TableRNumberChange8
DECLARE SUB TableRVolumeChange8
DECLARE SUB TableRFreqChange8
DECLARE SUB TableREnvirChange8

DECLARE SUB TableRNumberChange9
DECLARE SUB TableRVolumeChange9
DECLARE SUB TableRFreqChange9
DECLARE SUB TableREnvirChange9

DECLARE SUB TableRNumberChange10
DECLARE SUB TableRVolumeChange10
DECLARE SUB TableRFreqChange10
DECLARE SUB TableREnvirChange10

DECLARE SUB TableRNumberChange11
DECLARE SUB TableRVolumeChange11
DECLARE SUB TableRFreqChange11
DECLARE SUB TableREnvirChange11

DECLARE SUB TableRNumberChange12
DECLARE SUB TableRVolumeChange12
DECLARE SUB TableRFreqChange12
DECLARE SUB TableREnvirChange12

DECLARE SUB TableRNumberChange13
DECLARE SUB TableRVolumeChange13
DECLARE SUB TableRFreqChange13
DECLARE SUB TableREnvirChange13

DECLARE SUB TableRNumberChange14
DECLARE SUB TableRVolumeChange14
DECLARE SUB TableRFreqChange14
DECLARE SUB TableREnvirChange14

DECLARE SUB TableRNumberChange15
DECLARE SUB TableRVolumeChange15
DECLARE SUB TableRFreqChange15
DECLARE SUB TableREnvirChange15

DECLARE SUB PlayTableAmb
DECLARE SUB PlayTableRnd(Z AS INTEGER)
DECLARE SUB PlayTableRnd0
DECLARE SUB PlayTableRnd1
DECLARE SUB PlayTableRnd2
DECLARE SUB PlayTableRnd3
DECLARE SUB PlayTableRnd4
DECLARE SUB PlayTableRnd5
DECLARE SUB PlayTableRnd6
DECLARE SUB PlayTableRnd7
DECLARE SUB PlayTableRnd8
DECLARE SUB PlayTableRnd8
DECLARE SUB PlayTableRnd10
DECLARE SUB PlayTableRnd11
DECLARE SUB PlayTableRnd12
DECLARE SUB PlayTableRnd13
DECLARE SUB PlayTableRnd14
DECLARE SUB PlayTableRnd15


DECLARE FUNCTION RED(Z AS INTEGER) AS BYTE
DECLARE FUNCTION GREEN(Z AS INTEGER) AS BYTE
DECLARE FUNCTION BLUE(Z AS INTEGER) AS BYTE


DECLARE SUB ChangeDirectories
DECLARE SUB ChangeDrive
DECLARE SUB LoadRscFile
DECLARE SUB SaveRscFile
DECLARE SUB InitScreen
DECLARE SUB DrawPicture555
DECLARE SUB ExitClick
DECLARE SUB FileOpen
DECLARE SUB FileSave
DECLARE SUB StoreBitmap (Z AS INTEGER)
DECLARE SUB RetrieveBitmap (Z AS INTEGER)
DECLARE SUB SelectSky(Sender AS QMENUITEM)
DECLARE SUB DrawSky555(Z AS INTEGER)
DECLARE SUB DrawSky(Z AS INTEGER)
DECLARE SUB SkyRGBto555(Z AS INTEGER)
DECLARE SUB SkyPaint
DECLARE SUB StoreSkyLight
DECLARE SUB DrawSkyLight
DECLARE SUB SkyLightPaint
DECLARE SUB GreyscaleSkyLight
DECLARE SUB SkyLightTo555
DECLARE SUB SkyLightRGBto555

DECLARE SUB CanvasPaint
DECLARE SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
DECLARE SUB DrawTexture (Z AS INTEGER)

DECLARE SUB ExportTGA (Image AS INTEGER)
DECLARE SUB ImportTGA (Image AS INTEGER)
DECLARE SUB LoadTGA (Image AS INTEGER)
DECLARE SUB SaveTGA (Image AS INTEGER)

DECLARE SUB ExportBMP16 (Image AS INTEGER)
DECLARE SUB ImportBMP16 (Image AS INTEGER)
DECLARE SUB LoadBMP16 (Image AS INTEGER)
DECLARE SUB SaveBMP16 (Image AS INTEGER)

DECLARE SUB ExportBMP32 (Image AS INTEGER)
DECLARE SUB ImportBMP32 (Image AS INTEGER)
DECLARE SUB LoadBMP32 (Image AS INTEGER)
DECLARE SUB SaveBMP32 (Image AS INTEGER)

DECLARE SUB ExportJPG (Image AS INTEGER)
DECLARE SUB ImportJPG (Image AS INTEGER)
DECLARE SUB LoadJPG (Image AS INTEGER)
DECLARE SUB SaveJPG (Image AS INTEGER)

DECLARE SUB ExportTGA_0
DECLARE SUB ImportTGA_0
DECLARE SUB ExportBMP16_0
DECLARE SUB ImportBMP16_0
DECLARE SUB ExportBMP32_0
DECLARE SUB ImportBMP32_0
DECLARE SUB ExportJPG_0
DECLARE SUB ImportJPG_0

DECLARE SUB ExportTGA_1
DECLARE SUB ImportTGA_1
DECLARE SUB ExportBMP16_1
DECLARE SUB ImportBMP16_1
DECLARE SUB ExportBMP32_1
DECLARE SUB ImportBMP32_1
DECLARE SUB ExportJPG_1
DECLARE SUB ImportJPG_1

DECLARE SUB ExportTGA_2
DECLARE SUB ImportTGA_2
DECLARE SUB ExportBMP16_2
DECLARE SUB ImportBMP16_2
DECLARE SUB ExportBMP32_2
DECLARE SUB ImportBMP32_2
DECLARE SUB ExportJPG_2
DECLARE SUB ImportJPG_2

DECLARE SUB ExportBMPgrey
DECLARE SUB ImportBMPgrey
DECLARE SUB LoadBMPgrey
DECLARE SUB SaveBMPgrey

DECLARE SUB RGBto555

DECLARE SUB PlayRnd
DECLARE SUB SaveRnd
DECLARE SUB LoadRnd

DECLARE SUB PlayAmb
DECLARE SUB SaveAmb
DECLARE SUB LoadAmb

DECLARE SUB EditFadeRGB
DECLARE SUB EditTranspRGB
DECLARE SUB SaveFadeRGB
DECLARE SUB SaveTranspRGB
DECLARE SUB CloseRGBcolors
DECLARE SUB EditFogForm
DECLARE SUB SaveFogForm
DECLARE SUB CloseFogForm
DECLARE SUB EditWaterForm
DECLARE SUB SaveWaterForm
DECLARE SUB CloseWaterForm
DECLARE SUB InitTableForm
DECLARE SUB EditTableForm
DECLARE SUB SaveTableForm
DECLARE SUB CloseTableForm

TYPE CAR_Face
	v1 AS INTEGER
	v2 AS INTEGER
	v3 AS INTEGER
	tax AS INTEGER
	tbx AS INTEGER
	tcx AS INTEGER
	tay AS INTEGER
	tby AS INTEGER
	tcy AS INTEGER
	Flags AS WORD
	DMask AS WORD
	Distant AS INTEGER
	FaceNext AS INTEGER
	group AS INTEGER
	reserv AS STRING * 12
END TYPE

TYPE CAR_Point3d
	x AS SINGLE
	y AS SINGLE
	z AS SINGLE
	owner AS SHORT
	hide AS SHORT
END TYPE

TYPE 3DF_Obj
	objName AS STRING * 32
	ox AS SINGLE
	oy AS SINGLE
	oz AS SINGLE
	owner AS SHORT
	hide AS SHORT
END TYPE

TYPE OBJ_Animation
      vCount1 AS INTEGER
      vCount2 AS INTEGER
	aniKPS AS INTEGER
	FramesCount AS INTEGER
	AniTime AS INTEGER
'      AniDataString AS STRING * 64*1024*3*2
'	aniData(63,1023,2) AS SHORT
END TYPE

TYPE OBJ_Info
	Radius AS INTEGER
	YLo AS INTEGER
	YHi AS INTEGER
	lineLength AS INTEGER
	lIntensity AS INTEGER
	circleRad AS INTEGER
	cIntensity AS INTEGER
	Flags AS INTEGER
	GrRad AS INTEGER
	DefLight AS INTEGER
	LastAniTime AS INTEGER
	BoundR AS SINGLE
	reserv AS STRING * 16
      VCount AS INTEGER
      FCount AS INTEGER
      OCount AS INTEGER
      TextureSize AS INTEGER
END TYPE

TYPE FogEntity
  fogRGB AS INTEGER
  YBegin AS SINGLE
  Mortal AS INTEGER
  Transp AS SINGLE
  FLimit AS SINGLE
END TYPE

TYPE RND_SoundFX
	length AS INTEGER
	lpData AS STRING * 1280*1024
END TYPE

TYPE TRD
    RNumber AS INTEGER
    RVolume AS INTEGER
    RFreq AS INTEGER
    REnvir AS WORD
    Flags AS WORD
END TYPE

TYPE TAmbient
    RSFXCount AS INTEGER
    AVolume AS INTEGER
'    RndTime AS INTEGER
END TYPE

TYPE WaterEntity
    tindex AS INTEGER
    wlevel AS INTEGER
    transp AS SINGLE
    fogRGB AS INTEGER
END TYPE

DIM AnimData(255,63,1023,2) AS SHORT
MEMSET(VARPTR(AnimData(0,0,0,0)),0,256*64*1024*3*SIZEOF(SHORT))

DIM TMPvCount1 AS INTEGER
DIM TMPvCount2 AS INTEGER
DIM TMPaniKPS AS INTEGER
DIM TMPFramesCount AS INTEGER
DIM TMPAniTime AS INTEGER
'DIM TMPaniInfo AS OBJ_Animation
DIM TMPaniCoord AS SHORT
DIM TMPObjInfo AS OBJ_Info

' DIM TMPsfxName AS STRING * 32
DIM TMPlength AS INTEGER
DIM TMPlpData AS STRING * 1280*1024
DIM TMPsfxTime AS INTEGER

DIM ObjsList(255) AS OBJ_Info
DIM AnimList(255) AS OBJ_Animation
' DIM PointList(255,1023) AS CAR_Point3d
' DIM TmpPoint AS CAR_Point3d
DIM PointList(255,1023,15) AS BYTE
' DIM FaceList(255,1023) AS CAR_Face
' DIM TmpFace AS CAR_Face
DIM FaceList(255,1023,63) AS BYTE
' DIM ObjList(255,1023) AS 3DF_Obj
DIM ObjList(255,1023,47) AS BYTE
' DIM SoundList(64) AS CAR_SoundFX
 DIM ObjTextures(255,255,255) AS WORD
' DIM ObjTextureList AS QBITMAP
'     ObjTextureList.Width = 256
'     ObjTextureList.Height = 256
'     ObjTextureList.Paint(0,0,0,0)    
 DIM ObjSprites(255,127,127) AS WORD
' DIM ObjSpriteList AS QBITMAP
'     ObjSpriteList.Width = 128
'     ObjSpriteList.Height = 128
'     ObjSpriteList.Paint(0,0,0,0)    
 DIM DawnSky(255,255) AS WORD
 DIM DaySky(255,255) AS WORD
 DIM NightSky(255,255) AS WORD
 DIM SkyLight(127,127) AS BYTE
' DIM AniFX(64) AS INTEGER
' DIM ModelName AS STRING * 32
' DIM AniCount AS INTEGER, SfxCount AS INTEGER, VCount AS INTEGER, FCount AS INTEGER, OCount AS INTEGER, TextureSize AS INTEGER, TextureHeight AS INTEGER
' DIM FileType AS INTEGER
' DIM AnimIndex AS INTEGER, SfxIndex AS INTEGER

DIM FogsList(255) AS FogEntity
DIM RndList(63) AS RND_SoundFX
DIM AmbList(63) AS RND_SoundFX
DIM RndTable(63,15) AS TRD
DIM RndAmbient(63) AS TAmbient
DIM WaterList(255) AS WaterEntity

DIM TexCount& AS INTEGER, ObjCount& AS INTEGER, DawnSkyR& AS INTEGER, DawnSkyG& AS INTEGER, DawnSkyB& AS INTEGER, DawnSkyTR& AS INTEGER, DawnSkyTG& AS INTEGER, DawnSkyTB& AS INTEGER
DIM DaySkyR& AS INTEGER, DaySkyG& AS INTEGER, DaySkyB& AS INTEGER, DaySkyTR& AS INTEGER, DaySkyTG& AS INTEGER, DaySkyTB& AS INTEGER, NightSkyR& AS INTEGER, NightSkyG& AS INTEGER
DIM NightSkyB& AS INTEGER, NightSkyTR& AS INTEGER, NightSkyTG& AS INTEGER, NightSkyTB& AS INTEGER

DIM FogCount& AS INTEGER, AmbCount& AS INTEGER, RndCount& AS INTEGER, WtrCount& AS INTEGER


DIM BitMap AS QBITMAP
    BitMap.Width = 128
    BitMap.Height = 128
    BitMap.Paint(0,0,0,0)    

DIM XBitMap AS QBITMAPex
    XBitMap.Width = 128
    XBitMap.Height = 128
    XBitMap.Paint(0,0,0,0)    

DIM TextureList AS QBITMAP
    TextureList.Width = 128
    TextureList.Height = 128
    TextureList.Paint(0,0,0,0)    
        
DIM SkyBitMap AS QBITMAP
    SkyBitMap.Width = 256
    SkyBitMap.Height = 256
    SkyBitMap.Paint(0,0,0,0)    

DIM SkyList AS QBITMAP
    SkyList.Width = 256
    SkyList.Height = 768
    SkyList.Paint(0,0,0,0)    

DIM SkyLightBitMap AS QBITMAP
    SkyLightBitMap.Width = 128
    SkyLightBitMap.Height = 128
    SkyLightBitMap.Paint(0,0,0,0)    

DIM Font AS QFont
    Font.Name = "Arial"
    Font.Size = 12
    Font.Color = &H00FF00

DIM TEX??(127,127)
DIM FileName$ as String
DIM MapFile$ as String
DIM FileType AS SHORT
DIM ObjType AS SHORT
DIM Q AS SHORT
DIM ROJO AS BYTE
DIM VERDE AS BYTE
DIM AZUL AS BYTE
DIM Indice AS SHORT
DIM SkyIndex AS SHORT
DIM ObjIndex AS SHORT
DIM TexIndex AS SHORT
DIM WaterIndex AS SHORT
DIM RndIndex as INTEGER              
DIM AmbIndex as INTEGER              
DIM FogIndex as INTEGER              
DIM TblIndex as INTEGER              
DIM TextureSize AS INTEGER
' DIM RestOfFile AS STRING * 16*1024*1024
' DIM RestOfFileSize AS INTEGER

DIM ChngDrv AS QMenuItem
    ChngDrv.Caption = "Change &Drive"
    ChngDrv.OnClick = ChangeDrive  

DIM OpenFile AS QMenuItem
    OpenFile.Caption = "&Open File"
    OpenFile.OnClick = FileOpen  

DIM SaveFile AS QMenuItem
    SaveFile.Caption = "&Save File"
    SaveFile.OnClick = FileSave  
    SaveFile.Enabled=False

DIM ExportPrj AS QMenuItem
    ExportPrj.Caption = "Export data as .prj"
    ExportPrj.OnClick = FilePrjExport
    ExportPrj.Enabled=False
    
DIM ExitPrg AS QMenuItem
    ExitPrg.Caption = "E&xit"
    ExitPrg.OnClick = ExitClick
        
DIM FileMenu AS QMenuItem
    FileMenu.Caption = "&File"
    FileMenu.AddItems OpenFile, SaveFile, ExportPrj, ExitPrg
 
DIM ShowMenu AS QMenuItem
    ShowMenu.Caption = "S&how"
    ShowMenu.Enabled=False
    


DIM SaveAsTGA AS QMenuItem
    SaveAsTGA.Caption = "as 16-bit TGA"
    SaveAsTGA.OnClick = ExportTGA_0
    SaveAsTGA.Enabled=True
        
DIM LoadFromTGA AS QMenuItem
    LoadFromTGA.Caption = "from 16-bit TGA"
    LoadFromTGA.OnClick = ImportTGA_0
    LoadFromTGA.Enabled=True


DIM SaveAsBMP16 AS QMenuItem
    SaveAsBMP16.Caption = "as 16-bit BMP"
    SaveAsBMP16.OnClick = ExportBMP16_0
    SaveAsBMP16.Enabled=True
    
DIM LoadFromBMP16 AS QMenuItem
    LoadFromBMP16.Caption = "from 16-bit BMP"
    LoadFromBMP16.OnClick = importBMP16_0
    LoadFromBMP16.Enabled=True
    

DIM SaveAsBMP32 AS QMenuItem
    SaveAsBMP32.Caption = "as 32-bit BMP"
    SaveAsBMP32.OnClick = ExportBMP32_0
    SaveAsBMP32.Enabled=True

DIM LoadFromBMP32 AS QMenuItem
    LoadFromBMP32.Caption = "from 24/32-bit BMP"
    LoadFromBMP32.OnClick = ImportBMP32_0
    LoadFromBMP32.Enabled=True


DIM LoadFromVarious AS QMenuItem
    LoadFromVarious.Caption = "from image file"
    LoadFromVarious.OnClick = ImportJPG_0
    LoadFromVarious.Enabled=(NViewLibPresent>0)


DIM SaveAsJPG AS QMenuItem
    SaveAsJPG.Caption = "as JPEG"
    SaveAsJPG.OnClick = ExportJPG_0
    SaveAsJPG.Enabled=(NViewLibPresent AND 1)

DIM SaveTexture AS QMenuItem
    SaveTexture.Caption = "&Save"
    SaveTexture.Enabled=True
    SaveTexture.AddItems SaveAsTGA, SaveAsBMP16, SaveAsBMP32, SaveAsJPG

    
DIM LoadTexture AS QMenuItem
    LoadTexture.Caption = "&Replace"
    LoadTexture.Enabled=True
    LoadTexture.AddItems LoadFromTGA, LoadFromBMP16, LoadFromBMP32, LoadFromVarious


DIM TextureMenu AS QMenuItem
    TextureMenu.Caption = "&Terrain"
    TextureMenu.Enabled=False
    TextureMenu.OnClick = EditTexForm

DIM TexFileMenu AS QMenuItem
    TexFileMenu.Caption = "&Texture"
    TexFileMenu.Enabled=True
    TexFileMenu.AddItems SaveTexture, Loadtexture

DIM SaveSkyAsTGA AS QMenuItem
    SaveSkyAsTGA.Caption = "as 16-bit TGA"
    SaveSkyAsTGA.OnClick = ExportTGA_1
    SaveSkyAsTGA.Enabled=True
        
DIM LoadSkyFromTGA AS QMenuItem
    LoadSkyFromTGA.Caption = "from 16-bit TGA"
    LoadSkyFromTGA.OnClick = ImportTGA_1
    LoadSkyFromTGA.Enabled=True


DIM SaveSkyAsBMP16 AS QMenuItem
    SaveSkyAsBMP16.Caption = "as 16-bit BMP"
    SaveSkyAsBMP16.OnClick = ExportBMP16_1
    SaveSkyAsBMP16.Enabled=True
    
DIM LoadSkyFromBMP16 AS QMenuItem
    LoadSkyFromBMP16.Caption = "from 16-bit BMP"
    LoadSkyFromBMP16.OnClick = importBMP16_1
    LoadSkyFromBMP16.Enabled=True
    

DIM SaveSkyAsBMP32 AS QMenuItem
    SaveSkyAsBMP32.Caption = "as 32-bit BMP"
    SaveSkyAsBMP32.OnClick = ExportBMP32_1
    SaveSkyAsBMP32.Enabled=True

DIM LoadSkyFromBMP32 AS QMenuItem
    LoadSkyFromBMP32.Caption = "from 24/32-bit BMP"
    LoadSkyFromBMP32.OnClick = ImportBMP32_1
    LoadSkyFromBMP32.Enabled=True


DIM LoadSkyFromVarious AS QMenuItem
    LoadSkyFromVarious.Caption = "from image file"
    LoadSkyFromVarious.OnClick = ImportJPG_1
    LoadSkyFromVarious.Enabled=(NViewLibPresent>0)


DIM SaveSkyAsJPG AS QMenuItem
    SaveSkyAsJPG.Caption = "as JPEG"
    SaveSkyAsJPG.OnClick = ExportJPG_1
    SaveSkyAsJPG.Enabled=(NViewLibPresent AND 1)


DIM SaveSky AS QMenuItem
    SaveSky.Caption = "&Save"
    SaveSky.Enabled=True
    SaveSky.AddItems SaveSkyAsTGA, SaveSkyAsBMP16, SaveSkyAsBMP32, SaveSkyAsJPG

    
DIM LoadSky AS QMenuItem
    LoadSky.Caption = "&Replace"
    LoadSky.Enabled=True
    LoadSky.AddItems LoadSkyFromTGA, LoadSkyFromBMP16, LoadSkyFromBMP32, LoadSkyFromVarious


DIM DawnMenu AS QMenuItem
    DawnMenu.Caption = "Da&wn sky"
    DawnMenu.Enabled=False
    DawnMenu.RadioItem=True
    DawnMenu.onClick=SelectSky

DIM DayMenu AS QMenuItem
    DayMenu.Caption = "&Day sky"
    DayMenu.Enabled=True
    DayMenu.RadioItem=True
    DayMenu.onClick=SelectSky

DIM NightMenu AS QMenuItem
    NightMenu.Caption = "&Night sky"
    NightMenu.Enabled=False
    NightMenu.RadioItem=True
    NightMenu.onClick=SelectSky


DIM SaveSkyLightAsTGA AS QMenuItem
    SaveSkyLightAsTGA.Caption = "as 16-bit TGA"
    SaveSkyLightAsTGA.OnClick = ExportTGA_2
    SaveSkyLightAsTGA.Enabled=True
        
DIM LoadSkyLightFromTGA AS QMenuItem
    LoadSkyLightFromTGA.Caption = "from 16-bit TGA"
    LoadSkyLightFromTGA.OnClick = ImportTGA_2
    LoadSkyLightFromTGA.Enabled=True

DIM SaveSkyLightAsBMP16 AS QMenuItem
    SaveSkyLightAsBMP16.Caption = "as 16-bit BMP"
    SaveSkyLightAsBMP16.OnClick = ExportBMP16_2
    SaveSkyLightAsBMP16.Enabled=True
    
DIM LoadSkyLightFromBMP16 AS QMenuItem
    LoadSkyLightFromBMP16.Caption = "from 16-bit BMP"
    LoadSkyLightFromBMP16.OnClick = importBMP16_2
    LoadSkyLightFromBMP16.Enabled=True
    
DIM SaveSkyLightAsBMP32 AS QMenuItem
    SaveSkyLightAsBMP32.Caption = "as 32-bit BMP"
    SaveSkyLightAsBMP32.OnClick = ExportBMP32_2
    SaveSkyLightAsBMP32.Enabled=True

DIM LoadSkyLightFromBMP32 AS QMenuItem
    LoadSkyLightFromBMP32.Caption = "from 24/32-bit BMP"
    LoadSkyLightFromBMP32.OnClick = ImportBMP32_2
    LoadSkyLightFromBMP32.Enabled=True


DIM LoadSkyLightFromVarious AS QMenuItem
    LoadSkyLightFromVarious.Caption = "from image file"
    LoadSkyLightFromVarious.OnClick = ImportJPG_2
    LoadSkyLightFromVarious.Enabled=(NViewLibPresent>0)


DIM SaveSkyLightAsJPG AS QMenuItem
    SaveSkyLightAsJPG.Caption = "as JPEG"
    SaveSkyLightAsJPG.OnClick = ExportJPG_2
    SaveSkyLightAsJPG.Enabled=(NViewLibPresent AND 1)


DIM SaveSkyLightAsBMPgrey AS QMenuItem
    SaveSkyLightAsBMPgrey.Caption = "as greyscale BMP"
    SaveSkyLightAsBMPgrey.OnClick = ExportBMPgrey
    SaveSkyLightAsBMPgrey.Enabled=True
    
DIM LoadSkyLightFromBMPgrey AS QMenuItem
    LoadSkyLightFromBMPgrey.Caption = "from greyscale BMP"
    LoadSkyLightFromBMPgrey.OnClick = importBMPgrey
    LoadSkyLightFromBMPgrey.Enabled=True
    

DIM SaveSkyLight AS QMenuItem
    SaveSkyLight.Caption = "&Save"
    SaveSkyLight.Enabled=True
    SaveSkyLight.AddItems SaveSkyLightAsTGA, SaveSkyLightAsBMP16, SaveSkyLightAsBMP32, SaveSkyLightAsJPG, SaveSkyLightAsBMPgrey
    
DIM LoadSkyLight AS QMenuItem
    LoadSkyLight.Caption = "&Replace"
    LoadSkyLight.Enabled=True
    LoadSkyLight.AddItems LoadSkyLightFromTGA, LoadSkyLightFromBMP16, LoadSkyLightFromBMP32, LoadSkyLightFromVarious, LoadSkyLightFromBMPgrey


DIM SkyLightMenu AS QMenuItem
    SkyLightMenu.Caption = "&Lightmap"
    SkyLightMenu.Enabled=True
    SkyLightMenu.AddItems SaveSkyLight, LoadSkyLight

DIM EditFade AS QMenuItem
    EditFade.Caption = "Edit &fade color"
    EditFade.Enabled=True
    EditFade.OnClick = EditFadeRGB

DIM EditTransp AS QMenuItem
    EditTransp.Caption = "Edit &transp color"
    EditTransp.Enabled=True
    EditTransp.OnClick = EditTranspRGB

DIM SkyMenu AS QMenuItem
    SkyMenu.Caption = "S&ky"
    SkyMenu.Enabled=False
    SkyMenu.AddItems DawnMenu, DayMenu, NightMenu, SaveSky, LoadSky, SkyLightMenu, EditFade, EditTransp

DIM FogMenu AS QMenuItem
    FogMenu.Caption = "&Fogs"
    FogMenu.Enabled=False
'    FogMenu.Enabled=True
    FogMenu.OnClick = EditFogForm    

DIM WaterMenu AS QMenuItem
    WaterMenu.Caption = "&Water"
    WaterMenu.Enabled=False
'    WaterMenu.Enabled=True
    WaterMenu.OnClick = EditWaterForm    

DIM ObjMenu AS QMenuItem
    ObjMenu.Caption = "&Objects"
    ObjMenu.Enabled=False
'    ObjMenu.Enabled=True
    ObjMenu.OnClick = EditObjForm    

DIM AmbSelect AS QMenuItem
    AmbSelect.Caption = "&Select"
    AmbSelect.Enabled=False

DIM AmbPlay AS QMenuItem
    AmbPlay.Caption = "Re&play"
    AmbPlay.Enabled=False
    AmbPlay.OnClick = PlayAmb  
        
DIM AmbSave AS QMenuItem
    AmbSave.Caption = "Sa&ve"
    AmbSave.Enabled=False
    AmbSave.OnClick = SaveAmb  

DIM AmbLoad AS QMenuItem
    AmbLoad.Caption = "&Replace"
    AmbLoad.Enabled=False
    AmbLoad.OnClick = LoadAmb  


DIM RndMenu AS QMenuItem
    RndMenu.Caption = "&Random Sounds"
    RndMenu.Enabled=False
    RndMenu.OnClick = EditRndForm

DIM AmbMenu AS QMenuItem
    AmbMenu.Caption = "&Ambient Sounds"
    AmbMenu.Enabled=False
    AmbMenu.OnClick = EditAmbForm

DIM TblMenu AS QMenuItem
    TblMenu.Caption = "Sounds &Table"
    TblMenu.Enabled=False
    TblMenu.OnClick = EditTableForm

DIM SndMenu AS QMenuItem
    SndMenu.Caption = "&Sounds"
    SndMenu.Enabled=False
    SndMenu.Additems RndMenu, AmbMenu, TblMenu

CREATE Form1 AS QForm
    IcoHandle = ICO_CARN
    Height = 256+4+18+20+2+22+4
    Width = 512+4+4
    BorderStyle = 2
    Caption="Carnivores 1/2/Ice Age .rsc File Editor -  (C) 2011 by M.A.Ch.F."
CREATE MainMenu AS QMainMenu
    AddItems FileMenu, TextureMenu, ObjMenu, SkyMenu, FogMenu, SndMenu, WaterMenu
END CREATE    
CREATE Canvas AS QCanvas
    Visible = False
    OnPaint = CanvasPaint
    OnMouseMove=CanvasMouseMove
END CREATE
CREATE SkyCanvas AS QCanvas
    Visible = False
    Left=128
    Width=256
    Height=256
    OnPaint = SkyPaint
'    OnMouseMove=SkyMouseMove
END CREATE
CREATE SkyLightCanvas AS QCanvas
    Visible = False
    Left=384
    Width=128
    Height=128
    OnPaint = SkyLightPaint
'    OnMouseMove=SkyLightMouseMove
END CREATE
CREATE Status1 AS QStatusBar
    Enabled = True
    Height = 24
    SimplePanel = True
END CREATE
CREATE RGBForm AS QForm
  IcoHandle = ICO_CARN
  Height = 280
  Width = 300
  BorderStyle = 3
  CREATE LabelRed AS QLabel
    Left = 10
    Top = 22
    Caption = "Red:"
  END CREATE
  CREATE LabelGreen AS QLabel
    Left = 5
    Top = 52
    Caption = "Green:"
  END CREATE
  CREATE LabelBlue AS QLabel
    Left = 10
    Top = 82
    Caption = "Blue:"
  END CREATE
  CREATE LabelNum1 AS QLabel
    Left = 270
    Top = 22
    Caption = "0"
  END CREATE
  CREATE LabelNum2 AS QLabel
    Left = 270
    Top = 52
    Caption = "0"
  END CREATE
  CREATE LabelNum3 AS QLabel
    Left = 270
    Top = 82
    Caption = "0"
  END CREATE
  CREATE ScrollRed AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Red Attribute"
    OnChange = ColorChange
  END CREATE
  CREATE ScrollGreen AS QScrollBar
    Left = 50
    Top = 50
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Green Attribute"
    OnChange = ColorChange
  END CREATE
  CREATE ScrollBlue AS QScrollBar
    Left = 50
    Top = 80
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Blue Attribute"
    OnChange = ColorChange
  END CREATE
  CREATE PaintBox AS QCanvas
    Left = 50
    Top = 110
    Height = 90
    Width = 200
    OnPaint = RGBPaint
  END CREATE
CREATE SaveColors AS QButton
  Parent = RGBForm
  Left = 20
  Top = 210
  Width = 110
  Caption = "Save changes"
'  OnClick = SaveRGBcolors
END CREATE
CREATE CancelColors AS QButton
  Parent = RGBForm
  Left = 160
  Top = 210
  Width = 110
  Caption = "Cancel"
  OnClick = CloseRGBcolors
END CREATE
  Caption = "Color Palette"
    WindowState=0
    Visible=False
END CREATE

CREATE TexForm AS QForm
CREATE TexMainMenu AS QMainMenu
    AddItems TexFileMenu
END CREATE
    IcoHandle = ICO_CARN
    BorderStyle = 2
  Height = 160+128
  Width = 300
  CREATE TexLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "Tex:"
  END CREATE
    CREATE TexLabelNum0 AS QLabel
    Left = 270
    Top = 22
    Caption = "0"
  END CREATE
  CREATE TexScrollSelect AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Texture Index"
    OnChange = TexNumberChange
  END CREATE
  CREATE TextureBox AS QCanvas
    Left = 85
    Top = 50
    Height = 128
    Width = 128
    OnPaint = TexPaint
  END CREATE
CREATE CloseTex AS QButton
  Parent = TexForm
  Left = 160
  Top = 100+112
  Width = 110
  Caption = "Close"
  OnClick = CloseTexForm
END CREATE
    WindowState=0
    Visible=False
END CREATE

CREATE RndForm AS QForm
'    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 160
  Width = 300
  CREATE RndLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "Rnd:"
  END CREATE
    CREATE RndLabelNum0 AS QLabel
    Left = 270
    Top = 22
    Caption = "0"
  END CREATE
  CREATE RndScrollSelect AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Random Sound Index"
    OnChange = RndNumberChange
  END CREATE
CREATE SaveRndB AS QButton
  Parent = RndForm
  Left = 20
  Top = 60
  Width = 110
  Caption = "Save as WAV"
  OnClick = SaveRnd
END CREATE
CREATE LoadRndB AS QButton
  Parent = RndForm
  Left = 160
  Top = 60
  Width = 110
  Caption = "Replace from WAV"
  OnClick = LoadRnd
END CREATE
CREATE PlayRndB AS QButton
  Parent = RndForm
  Left = 20
  Top = 100
  Width = 110
  Caption = "Play Random Sound"
  OnClick = PlayRnd
END CREATE
CREATE CloseRnd AS QButton
  Parent = RndForm
  Left = 160
  Top = 100
  Width = 110
  Caption = "Close"
  OnClick = CloseRndForm
END CREATE
  Caption = "Random Sounds"
    WindowState=0
    Visible=False
END CREATE

CREATE AmbForm AS QForm
'    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 160
  Width = 300
  CREATE AmbLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "Amb:"
  END CREATE
    CREATE AmbLabelNum0 AS QLabel
    Left = 270
    Top = 22
    Caption = "0"
  END CREATE
  CREATE AmbScrollSelect AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Ambient Sound Index"
    OnChange = AmbNumberChange
  END CREATE
CREATE SaveAmbB AS QButton
  Parent = AmbForm
  Left = 20
  Top = 60
  Width = 110
  Caption = "Save as WAV"
  OnClick = SaveAmb
END CREATE
CREATE LoadAmbB AS QButton
  Parent = AmbForm
  Left = 160
  Top = 60
  Width = 110
  Caption = "Replace from WAV"
  OnClick = LoadAmb
END CREATE
CREATE PlayAmbB AS QButton
  Parent = AmbForm
  Left = 20
  Top = 100
  Width = 110
  Caption = "Play Ambient Sound"
  OnClick = PlayAmb
END CREATE
CREATE CloseAmb AS QButton
  Parent = AmbForm
  Left = 160
  Top = 100
  Width = 110
  Caption = "Close"
  OnClick = CloseAmbForm
END CREATE
  Caption = "Ambient Sounds"
    WindowState=0
    Visible=False
END CREATE

CREATE FogForm AS QForm
    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 430
  Width = 300
  CREATE FogLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "Fog:"
  END CREATE
  CREATE FogLabelRed AS QLabel
    Left = 10
    Top = 52
    Caption = "Red:"
  END CREATE
  CREATE FogLabelGreen AS QLabel
    Left = 5
    Top = 82
    Caption = "Green:"
  END CREATE
  CREATE FogLabelBlue AS QLabel
    Left = 10
    Top = 112
    Caption = "Blue:"
  END CREATE
  CREATE FogLabelNum0 AS QLabel
    Left = 270
    Top = 22
    Caption = "0"
  END CREATE
  CREATE FogLabelNum1 AS QLabel
    Left = 270
    Top = 52
    Caption = "0"
  END CREATE
  CREATE FogLabelNum2 AS QLabel
    Left = 270
    Top = 82
    Caption = "0"
  END CREATE
  CREATE FogLabelNum3 AS QLabel
    Left = 270
    Top = 112
    Caption = "0"
  END CREATE
  CREATE FogLabelYBegin AS QLabel
    Left = 5
    Top = 242
    Caption = "Y begin:"
  END CREATE
  CREATE FogLabelNumY AS QLabel
    Left = 270
    Top = 242
    Caption = "0"
  END CREATE
  CREATE FogLabelTransp AS QLabel
    Left = 5
    Top = 302
    Caption = "Transp:"
  END CREATE
  CREATE FogLabelNumTransp AS QLabel
    Left = 265
    Top = 302
    Caption = "0"
  END CREATE
  CREATE FogLabelFLimit AS QLabel
    Left = 5
    Top = 332
    Caption = "F limit:"
  END CREATE
  CREATE FogLabelNumFLimit AS QLabel
    Left = 270
    Top = 332
    Caption = "0"
  END CREATE
  CREATE FogCheckboxMortal AS QCheckBox
    Left = 110
    Top = 272
    Caption = "Mortal"
    Checked = False
  END CREATE
  CREATE FogScrollSelect AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Fog Index"
    OnChange = FogNumberChange
  END CREATE
  CREATE FogScrollRed AS QScrollBar
    Left = 50
    Top = 50
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Red Attribute"
    OnChange = FogColorChange
  END CREATE
  CREATE FogScrollGreen AS QScrollBar
    Left = 50
    Top = 80
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Green Attribute"
    OnChange = FogColorChange
  END CREATE
  CREATE FogScrollBlue AS QScrollBar
    Left = 50
    Top = 110
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Blue Attribute"
    OnChange = FogColorChange
  END CREATE
  CREATE FogPaintBox AS QCanvas
    Left = 50
    Top = 140
    Height = 90
    Width = 200
    OnPaint = FogRGBPaint
  END CREATE
  CREATE FogScrollYBegin AS QScrollBar
    Left = 50
    Top = 240
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Fog Starting Height"
    OnChange = FogYBeginChange
  END CREATE
  CREATE FogScrollTransp AS QScrollBar
    Left = 50
    Top = 300
    Width = 200
    Height = 20
    Min = 0: Max = 1024
    ShowHint =  True
    Hint = "Fog Transparency"
    OnChange = FogTranspChange
  END CREATE
  CREATE FogScrollFLimit AS QScrollBar
    Left = 50
    Top = 330
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Fog Far Limit"
    OnChange = FogFLimitChange
  END CREATE
CREATE SaveFog AS QButton
  Parent = FogForm
  Left = 20
  Top = 360
  Width = 110
  Caption = "Apply"
  OnClick = SaveFogForm
END CREATE
CREATE CloseFog AS QButton
  Parent = FogForm
  Left = 160
  Top = 360
  Width = 110
  Caption = "Close"
  OnClick = CloseFogForm
END CREATE
  Caption = "Fog settings"
    WindowState=0
    Visible=False
END CREATE

CREATE WaterForm AS QForm
    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 540
  Width = 300
  CREATE WaterLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "Water:"
  END CREATE
  CREATE WaterLabelRed AS QLabel
    Left = 10
    Top = 52
    Caption = "Red:"
  END CREATE
  CREATE WaterLabelGreen AS QLabel
    Left = 5
    Top = 82
    Caption = "Green:"
  END CREATE
  CREATE WaterLabelBlue AS QLabel
    Left = 10
    Top = 112
    Caption = "Blue:"
  END CREATE
  CREATE WaterLabelNum0 AS QLabel
    Left = 270
    Top = 22
    Caption = "0"
  END CREATE
  CREATE WaterLabelNum1 AS QLabel
    Left = 270
    Top = 52
    Caption = "0"
  END CREATE
  CREATE WaterLabelNum2 AS QLabel
    Left = 270
    Top = 82
    Caption = "0"
  END CREATE
  CREATE WaterLabelNum3 AS QLabel
    Left = 270
    Top = 112
    Caption = "0"
  END CREATE
  CREATE WaterLabelWlevel AS QLabel
    Left = 5
    Top = 242
    Caption = "Level:"
  END CREATE
  CREATE WaterLabelNumWlevel AS QLabel
    Left = 270
    Top = 242
    Caption = "0"
  END CREATE
  CREATE WaterLabelTransp AS QLabel
    Left = 5
    Top = 272
    Caption = "Transp:"
  END CREATE
  CREATE WaterLabelNumTransp AS QLabel
    Left = 270
    Top = 272
    Caption = "0"
  END CREATE
  CREATE WaterLabelTindex AS QLabel
    Left = 5
    Top = 302
    Caption = "Texture:"
  END CREATE
  CREATE WaterLabelNumTindex AS QLabel
    Left = 270
    Top = 302
    Caption = "0"
  END CREATE
  CREATE WaterScrollSelect AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Water Index"
    OnChange = WaterNumberChange
  END CREATE
  CREATE WaterScrollRed AS QScrollBar
    Left = 50
    Top = 50
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Red Attribute"
    OnChange = WaterColorChange
  END CREATE
  CREATE WaterScrollGreen AS QScrollBar
    Left = 50
    Top = 80
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Green Attribute"
    OnChange = WaterColorChange
  END CREATE
  CREATE WaterScrollBlue AS QScrollBar
    Left = 50
    Top = 110
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Blue Attribute"
    OnChange = WaterColorChange
  END CREATE
  CREATE WaterPaintBox AS QCanvas
    Left = 50
    Top = 140
    Height = 90
    Width = 200
    OnPaint = WaterRGBPaint
  END CREATE
  CREATE WaterScrollWlevel AS QScrollBar
    Left = 50
    Top = 240
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Water Level"
    OnChange = WaterWlevelChange
  END CREATE
  CREATE WaterScrollTransp AS QScrollBar
    Left = 50
    Top = 270
    Width = 200
    Height = 20
    Min = 0: Max = 20
    ShowHint =  True
    Hint = "Water Transparency"
    OnChange = WaterTranspChange
  END CREATE
  CREATE WaterScrollTindex AS QScrollBar
    Left = 50
    Top = 300
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Water Texture Index"
    OnChange = WaterTindexChange
  END CREATE
  CREATE WaterTextureBox AS QCanvas
    Left = 85
    Top = 330
    Height = 128
    Width = 128
    OnPaint = WaterTexPaint
  END CREATE
CREATE SaveWater AS QButton
  Parent = WaterForm
  Left = 20
  Top = 470
  Width = 110
  Caption = "Apply"
  OnClick = SaveWaterForm
END CREATE
CREATE CloseWater AS QButton
  Parent = WaterForm
  Left = 160
  Top = 470
  Width = 110
  Caption = "Close"
  OnClick = CloseWaterForm
END CREATE
  Caption = "Water settings"
    WindowState=0
    Visible=False
END CREATE

CREATE ObjForm AS QForm
'    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 160+256
  Width = 300
  CREATE ObjLabelSel AS QLabel
    Left = 10
    Top = 22+256
    Caption = "Obj:"
  END CREATE
    CREATE ObjLabelNum0 AS QLabel
    Left = 270
    Top = 22+256
    Caption = "0"
  END CREATE
  CREATE ObjScrollSelect AS QScrollBar
    Left = 50
    Top = 20+256
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Object Index"
    OnChange = ObjNumberChange
  END CREATE
CREATE SaveObj1 AS QButton
  Parent = ObjForm
  Left = 20
  Top = 60+256
  Width = 110
  Caption = "Save as C1 Object"
  OnClick = Obj1Save
END CREATE
CREATE LoadObj AS QButton
  Parent = ObjForm
  Left = 160
  Top = 60+256
  Width = 110
  Caption = "Replace Object"
  OnClick = ObjLoad
END CREATE
CREATE SaveObj2 AS QButton
  Parent = ObjForm
  Left = 20
  Top = 100+256
  Width = 110
  Caption = "Save as C2/IA Object"
  OnClick = Obj2Save
END CREATE
CREATE CloseObj AS QButton
  Parent = ObjForm
  Left = 160
  Top = 100+256
  Width = 110
  Caption = "Close"
  OnClick = CloseObjForm
END CREATE
  Caption = "3D Objects"
    WindowState=0
    Visible=False
END CREATE

CREATE TableForm AS QForm
    IcoHandle = ICO_CARN
    BorderStyle = 3
    FormStyle=fsStayOnTop
  Height = 640
  Width = 720
  Parent=Form1
  CREATE TableLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "Amb Snd:"
    OnClick=PlayTableAmb
  END CREATE
  CREATE TableLabelNum0 AS QLabel
    Left = 200
    Top = 22
    Caption = "0"
  END CREATE
  CREATE TableScrollSelect AS QScrollBar
    Left = 80
    Top = 20
    Width = 100
    Height = 20
    Min = 0: Max = 64
    ShowHint =  True
    Hint = "Ambient Sound Index"
    OnChange = TableNumberChange
  END CREATE

  CREATE TableAVolumeLabel AS QLabel
Left = 230
Top = 22
Caption = "Vol:"
  END CREATE
  CREATE TableAVolume AS QScrollBar
Left = 260
Top = 20
Width = 100
Height = 20
Min = 0: Max = 256
ShowHint =  True
Hint = "Ambient Sound Volume"
    OnChange = TableAVolumeChange
  END CREATE
  CREATE TableAVolumeNum AS QLabel
Left = 380
Top = 22
Caption = "0"
  END CREATE

  CREATE TableRSFXCountLabel AS QLabel
    Left = 410
    Top = 22
    Caption = "Rnd Snds:"
  END CREATE
  CREATE TableRSFXCountNum AS QLabel
    Left = 600
    Top = 22
    Caption = "0"
  END CREATE
  CREATE TableRSFXCount AS QScrollBar
    Left = 480
    Top = 20
    Width = 100
    Height = 20
    Min = 0: Max = 16
    ShowHint =  True
    Hint = "Number of Random Sounds"
    OnChange = TableRSFXCountChange
  END CREATE

CREATE SaveTable AS QButton
  Parent = TableForm
  Left = 220
  Top = 570
  Width = 110
  Caption = "Apply"
  OnClick = SaveTableForm
END CREATE
CREATE CloseTable AS QButton
  Parent = TableForm
  Left = 360
  Top = 570
  Width = 110
  Caption = "Close"
  OnClick = CloseTableForm
END CREATE
CREATE TableRVolumeLabel AS QLabel
Left = 260
Top = 52
Caption = "Volume"
END CREATE
CREATE TableRFreqNumLabel AS QLabel
Left = 405
Top = 52
Caption = "Frequency"
END CREATE
CREATE TableREnvirNumLabel AS QLabel
Left = 550
Top = 52
Caption = "Environment"
END CREATE
CREATE TableFlagsLabel AS QLabel
Left = 675
Top = 52
Caption = "Flag"
END CREATE
'    Visible=False
'    Show
END CREATE
    Center
'    Visible=True
'  ShowModal
END CREATE

  TexForm.Caption = "Terrain textures"

SUB InitMesh
DIM I AS INTEGER
DIM V1 AS INTEGER, V2 AS INTEGER, V3 AS INTEGER
DIM PX AS SINGLE, PY AS SINGLE, PZ AS SINGLE

      meshList=glGenLists(1)
      glNewList(meshList,GL_COMPILE)
glBegin(GL_POINTS)
glColor3f(1.0,1.0,1.0)
glVertex3f(0,0,0)
glEnd
 
glBegin(GL_LINES)
glColor3f(1.0,0.0,0.0)
glVertex3f(10,0,0)
glVertex3f(-10,0,0)
glColor3f(0.0,1.0,0.0)
glVertex3f(0,10,0)
glVertex3f(0,-10,0)
glColor3f(0.0,0.0,1.0)
glVertex3f(0,0,10)
glVertex3f(0,0,-10)
glEnd
 
    glEndList
END SUB

  DIM TableLabelName(15) AS QLabel
  DIM TableLabelNum(15) AS QLabel
  DIM TableScroll(15) AS QScrollBar
'    DIM TableRNumber(15) AS QScrollBar
    DIM TableRVolume(15) AS QScrollBar
    DIM TableRVolumeNum(15) AS QLabel
    DIM TableRFreq(15) AS QScrollBar
    DIM TableRFreqNum(15) AS QLabel
    DIM TableREnvir(15) AS QScrollBar
    DIM TableREnvirNum(15) AS QLabel
    DIM TableFlags(15) AS QCheckBox

' SUB InitTableForm
FOR CONTADOR = 0 TO 15
TableLabelName(CONTADOR).Parent=TableForm
TableLabelName(CONTADOR).Left = 10
TableLabelName(CONTADOR).Top = 82+30*CONTADOR
TableLabelName(CONTADOR).Caption = "Rnd Snd #"+STR$(CONTADOR+1)+":"
TableLabelNum(CONTADOR).Parent=TableForm
TableLabelNum(CONTADOR).Left = 200
TableLabelNum(CONTADOR).Top = 82+30*CONTADOR
TableLabelNum(CONTADOR).Caption = "0"
TableScroll(CONTADOR).Parent=TableForm
TableScroll(CONTADOR).Left = 80
TableScroll(CONTADOR).Top = 80+30*CONTADOR
TableScroll(CONTADOR).Width = 100
TableScroll(CONTADOR).Height = 20
TableScroll(CONTADOR).Min = 0: TableScroll(CONTADOR).Max = 63
TableScroll(CONTADOR).ShowHint =  True
TableScroll(CONTADOR).Hint = "Random Sound "+STR$(CONTADOR+1)+" Index"
'    TableScroll(CONTADOR).OnChange = TableNumberChange

TableRVolume(CONTADOR).Parent=TableForm
TableRVolume(CONTADOR).Left = 230
TableRVolume(CONTADOR).Top = 80+30*CONTADOR
TableRVolume(CONTADOR).Width = 100
TableRVolume(CONTADOR).Height = 20
TableRVolume(CONTADOR).Min = 0: TableRVolume(CONTADOR).Max = 256
TableRVolume(CONTADOR).ShowHint =  True
TableRVolume(CONTADOR).Hint = "Random Sound "+STR$(CONTADOR+1)+" Volume"
TableRVolumeNum(CONTADOR).Parent=TableForm
TableRVolumeNum(CONTADOR).Left = 350
TableRVolumeNum(CONTADOR).Top = 82+30*CONTADOR
TableRVolumeNum(CONTADOR).Caption = "0"

TableRFreq(CONTADOR).Parent=TableForm
TableRFreq(CONTADOR).Left = 380
TableRFreq(CONTADOR).Top = 80+30*CONTADOR
TableRFreq(CONTADOR).Width = 100
TableRFreq(CONTADOR).Height = 20
TableRFreq(CONTADOR).Min = 0: TableRFreq(CONTADOR).Max = 255
TableRFreq(CONTADOR).ShowHint =  True
TableRFreq(CONTADOR).Hint = "Random Sound "+STR$(CONTADOR+1)+" Frequency"
TableRFreqNum(CONTADOR).Parent=TableForm
TableRFreqNum(CONTADOR).Left = 500
TableRFreqNum(CONTADOR).Top = 82+30*CONTADOR
TableRFreqNum(CONTADOR).Caption = "0"

TableREnvir(CONTADOR).Parent=TableForm
TableREnvir(CONTADOR).Left = 530
TableREnvir(CONTADOR).Top = 80+30*CONTADOR
TableREnvir(CONTADOR).Width = 100
TableREnvir(CONTADOR).Height = 20
TableREnvir(CONTADOR).Min = 0: TableREnvir(CONTADOR).Max = 25
TableREnvir(CONTADOR).ShowHint =  True
TableREnvir(CONTADOR).Hint = "Random Sound "+STR$(CONTADOR+1)+" Environment"
TableREnvirNum(CONTADOR).Parent=TableForm
TableREnvirNum(CONTADOR).Left = 650
TableREnvirNum(CONTADOR).Top = 82+30*CONTADOR
TableREnvirNum(CONTADOR).Caption = "0"

TableFlags(CONTADOR).Parent=TableForm
TableFlags(CONTADOR).Left = 680
TableFlags(CONTADOR).Top = 80+30*CONTADOR
TableFlags(CONTADOR).Checked = False
TableFlags(CONTADOR).ShowHint =  True
TableFlags(CONTADOR).Hint = "Mark Random Sound "+STR$(CONTADOR+1)+" unavailable in Night Mode"

'Status1.Simpletext="Added Random sound #"+STR$(CONTADOR+1)
NEXT CONTADOR
TableScroll(0).OnChange=TableRNumberChange0
TableRVolume(0).OnChange=TableRVolumeChange0
TableRFreq(0).OnChange=TableRFreqChange0
TableREnvir(0).OnChange=TableREnvirChange0

TableScroll(1).OnChange=TableRNumberChange1
TableRVolume(1).OnChange=TableRVolumeChange1
TableRFreq(1).OnChange=TableRFreqChange1
TableREnvir(1).OnChange=TableREnvirChange1

TableScroll(2).OnChange=TableRNumberChange2
TableRVolume(2).OnChange=TableRVolumeChange2
TableRFreq(2).OnChange=TableRFreqChange2
TableREnvir(2).OnChange=TableREnvirChange2

TableScroll(3).OnChange=TableRNumberChange3
TableRVolume(3).OnChange=TableRVolumeChange3
TableRFreq(3).OnChange=TableRFreqChange3
TableREnvir(3).OnChange=TableREnvirChange3

TableScroll(4).OnChange=TableRNumberChange4
TableRVolume(4).OnChange=TableRVolumeChange4
TableRFreq(4).OnChange=TableRFreqChange4
TableREnvir(4).OnChange=TableREnvirChange4

TableScroll(5).OnChange=TableRNumberChange5
TableRVolume(5).OnChange=TableRVolumeChange5
TableRFreq(5).OnChange=TableRFreqChange5
TableREnvir(5).OnChange=TableREnvirChange5

TableScroll(6).OnChange=TableRNumberChange6
TableRVolume(6).OnChange=TableRVolumeChange6
TableRFreq(6).OnChange=TableRFreqChange6
TableREnvir(6).OnChange=TableREnvirChange6

TableScroll(7).OnChange=TableRNumberChange7
TableRVolume(7).OnChange=TableRVolumeChange7
TableRFreq(7).OnChange=TableRFreqChange7
TableREnvir(7).OnChange=TableREnvirChange7

TableScroll(8).OnChange=TableRNumberChange8
TableRVolume(8).OnChange=TableRVolumeChange8
TableRFreq(8).OnChange=TableRFreqChange8
TableREnvir(8).OnChange=TableREnvirChange8

TableScroll(9).OnChange=TableRNumberChange9
TableRVolume(9).OnChange=TableRVolumeChange9
TableRFreq(9).OnChange=TableRFreqChange9
TableREnvir(9).OnChange=TableREnvirChange9

TableScroll(10).OnChange=TableRNumberChange10
TableRVolume(10).OnChange=TableRVolumeChange10
TableRFreq(10).OnChange=TableRFreqChange10
TableREnvir(10).OnChange=TableREnvirChange10

TableScroll(11).OnChange=TableRNumberChange11
TableRVolume(11).OnChange=TableRVolumeChange11
TableRFreq(11).OnChange=TableRFreqChange11
TableREnvir(11).OnChange=TableREnvirChange11

TableScroll(12).OnChange=TableRNumberChange12
TableRVolume(12).OnChange=TableRVolumeChange12
TableRFreq(12).OnChange=TableRFreqChange12
TableREnvir(12).OnChange=TableREnvirChange12

TableScroll(13).OnChange=TableRNumberChange13
TableRVolume(13).OnChange=TableRVolumeChange13
TableRFreq(13).OnChange=TableRFreqChange13
TableREnvir(13).OnChange=TableREnvirChange13

TableScroll(14).OnChange=TableRNumberChange14
TableRVolume(14).OnChange=TableRVolumeChange14
TableRFreq(14).OnChange=TableRFreqChange14
TableREnvir(14).OnChange=TableREnvirChange14

TableScroll(15).OnChange=TableRNumberChange15
TableRVolume(15).OnChange=TableRVolumeChange15
TableRFreq(15).OnChange=TableRFreqChange15
TableREnvir(15).OnChange=TableREnvirChange15

TableLabelName(0).OnCLick=PlayTableRnd0
TableLabelName(1).OnCLick=PlayTableRnd1
TableLabelName(2).OnCLick=PlayTableRnd2
TableLabelName(3).OnCLick=PlayTableRnd3
TableLabelName(4).OnCLick=PlayTableRnd4
TableLabelName(5).OnCLick=PlayTableRnd5
TableLabelName(6).OnCLick=PlayTableRnd6
TableLabelName(7).OnCLick=PlayTableRnd7
TableLabelName(8).OnCLick=PlayTableRnd8
TableLabelName(9).OnCLick=PlayTableRnd8
TableLabelName(10).OnCLick=PlayTableRnd10
TableLabelName(11).OnCLick=PlayTableRnd11
TableLabelName(12).OnCLick=PlayTableRnd12
TableLabelName(13).OnCLick=PlayTableRnd13
TableLabelName(14).OnCLick=PlayTableRnd14
TableLabelName(15).OnCLick=PlayTableRnd15

TableForm.Caption = "Ambient/Random Sound Table"
TableForm.WindowState=0
' TableForm.Repaint
 TableForm.Visible=False
' TableForm.Show'Modal
' END SUB

Form1.ShowModal

SUB EditTableForm
TableScrollSelect.Position=TblIndex
TableLabelNum0.Caption=STR$(TblIndex)
 TableAVolume.Position=RndAmbient(TblIndex).AVolume
TableAVolumeNum.Caption=STR$(TableAVolume.Position)
 TableRSFXCount.Position=RndAmbient(TblIndex).RSFXCount
TableRSFXCountNum.Caption=STR$(TableRSFXCount.Position)
FOR CONTADOR=0 TO RndAmbient(TblIndex).RSFXCount-1
TableScroll(CONTADOR).Position=RndTable(TblIndex,CONTADOR).RNumber
TableRVolume(CONTADOR).Position=RndTable(TblIndex,CONTADOR).RVolume
TableRFreq(CONTADOR).Position=RndTable(TblIndex,CONTADOR).RFreq
TableREnvir(CONTADOR).Position=RndTable(TblIndex,CONTADOR).REnvir
TableFlags(CONTADOR).Checked=RndTable(TblIndex,CONTADOR).Flags
NEXT CONTADOR
FOR CONTADOR=RndAmbient(TblIndex).RSFXCount TO 15
TableScroll(CONTADOR).Position=0
TableRVolume(CONTADOR).Position=0
TableRFreq(CONTADOR).Position=0
TableREnvir(CONTADOR).Position=0
TableFlags(CONTADOR).Checked=0
NEXT CONTADOR
    TableForm.Visible=True
    TableForm.Show
END SUB

SUB SaveTableForm
TblIndex=TableScrollSelect.Position
RndAmbient(TblIndex).AVolume=TableAVolume.Position
RndAmbient(TblIndex).RSFXCount=TableRSFXCount.Position
FOR CONTADOR=0 TO RndAmbient(TblIndex).RSFXCount-1
RndTable(TblIndex,CONTADOR).RNumber=TableScroll(CONTADOR).Position
RndTable(TblIndex,CONTADOR).RVolume=TableRVolume(CONTADOR).Position
RndTable(TblIndex,CONTADOR).RFreq=TableRFreq(CONTADOR).Position
RndTable(TblIndex,CONTADOR).REnvir=TableREnvir(CONTADOR).Position
RndTable(TblIndex,CONTADOR).Flags=TableFlags(CONTADOR).Checked
NEXT CONTADOR
END SUB

SUB CloseTableForm
    TableForm.Close
END SUB

SUB TableNumberChange
TblIndex=TableScrollSelect.Position
TableLabelNum0.Caption=STR$(TblIndex)
TableAVolume.Position=RndAmbient(TblIndex).AVolume
RSFXCount=RndAmbient(TblIndex).RSFXCount
TableRSFXCount.Position=RSFXCount
FOR CONTADOR=0 TO RSFXCount-1
TableScroll(CONTADOR).Position=RndTable(TblIndex,CONTADOR).RNumber
TableRVolume(CONTADOR).Position=RndTable(TblIndex,CONTADOR).RVolume
TableRFreq(CONTADOR).Position=RndTable(TblIndex,CONTADOR).RFreq
TableREnvir(CONTADOR).Position=RndTable(TblIndex,CONTADOR).REnvir
TableFlags(CONTADOR).Checked=RndTable(TblIndex,CONTADOR).Flags
NEXT CONTADOR
FOR CONTADOR=RSFXCount TO 15
TableScroll(CONTADOR).Position=0
TableRVolume(CONTADOR).Position=0
TableRFreq(CONTADOR).Position=0
TableREnvir(CONTADOR).Position=0
TableFlags(CONTADOR).Checked=0
NEXT CONTADOR
'TableForm.Show
END SUB


SUB TableAVolumeChange
TableAVolumeNum.Caption=STR$(TableAVolume.Position)
END SUB

SUB TableRSFXCountChange
RSFXCount=TableRSFXCount.Position
TableRSFXCountNum.Caption=STR$(RSFXCount)
FOR CONTADOR=0 TO RSFXCount-1
TableScroll(CONTADOR).Position=RndTable(TblIndex,CONTADOR).RNumber
TableRVolume(CONTADOR).Position=RndTable(TblIndex,CONTADOR).RVolume
TableRFreq(CONTADOR).Position=RndTable(TblIndex,CONTADOR).RFreq
TableREnvir(CONTADOR).Position=RndTable(TblIndex,CONTADOR).REnvir
TableFlags(CONTADOR).Checked=RndTable(TblIndex,CONTADOR).Flags
NEXT CONTADOR
FOR CONTADOR=RSFXCount TO 15
TableScroll(CONTADOR).Position=0
TableRVolume(CONTADOR).Position=0
TableRFreq(CONTADOR).Position=0
TableREnvir(CONTADOR).Position=0
TableFlags(CONTADOR).Checked=0
NEXT CONTADOR
END SUB

SUB TableRNumberChange(Z AS INTEGER)
TableLabelNum(Z).Caption=STR$(TableScroll(Z).Position)
END SUB

SUB TableRVolumeChange(Z AS INTEGER)
TableRVolumeNum(Z).Caption=STR$(TableRVolume(Z).Position)
END SUB

SUB TableRFreqChange(Z AS INTEGER)
TableRFreqNum(Z).Caption=STR$(TableRFreq(Z).Position)
END SUB

SUB TableREnvirChange(Z AS INTEGER)
TableREnvirNum(Z).Caption=STR$(TableREnvir(Z).Position)
END SUB


SUB TableRNumberChange0
TableRNumberChange(0)
END SUB
SUB TableRVolumeChange0
TableRVolumeChange(0)
END SUB
SUB TableRFreqChange0
TableRFreqChange(0)
END SUB
SUB TableREnvirChange0
TableREnvirChange(0)
END SUB

SUB TableRNumberChange1
TableRNumberChange(1)
END SUB
SUB TableRVolumeChange1
TableRVolumeChange(1)
END SUB
SUB TableRFreqChange1
TableRFreqChange(1)
END SUB
SUB TableREnvirChange1
TableREnvirChange(1)
END SUB

SUB TableRNumberChange2
TableRNumberChange(2)
END SUB
SUB TableRVolumeChange2
TableRVolumeChange(2)
END SUB
SUB TableRFreqChange2
TableRFreqChange(2)
END SUB
SUB TableREnvirChange2
TableREnvirChange(2)
END SUB

SUB TableRNumberChange3
TableRNumberChange(3)
END SUB
SUB TableRVolumeChange3
TableRVolumeChange(3)
END SUB
SUB TableRFreqChange3
TableRFreqChange(3)
END SUB
SUB TableREnvirChange3
TableREnvirChange(3)
END SUB

SUB TableRNumberChange4
TableRNumberChange(4)
END SUB
SUB TableRVolumeChange4
TableRVolumeChange(4)
END SUB
SUB TableRFreqChange4
TableRFreqChange(4)
END SUB
SUB TableREnvirChange4
TableREnvirChange(4)
END SUB

SUB TableRNumberChange5
TableRNumberChange(5)
END SUB
SUB TableRVolumeChange5
TableRVolumeChange(5)
END SUB
SUB TableRFreqChange5
TableRFreqChange(5)
END SUB
SUB TableREnvirChange5
TableREnvirChange(5)
END SUB

SUB TableRNumberChange6
TableRNumberChange(6)
END SUB
SUB TableRVolumeChange6
TableRVolumeChange(6)
END SUB
SUB TableRFreqChange6
TableRFreqChange(6)
END SUB
SUB TableREnvirChange6
TableREnvirChange(6)
END SUB

SUB TableRNumberChange7
TableRNumberChange(7)
END SUB
SUB TableRVolumeChange7
TableRVolumeChange(7)
END SUB
SUB TableRFreqChange7
TableRFreqChange(7)
END SUB
SUB TableREnvirChange7
TableREnvirChange(7)
END SUB

SUB TableRNumberChange8
TableRNumberChange(8)
END SUB
SUB TableRVolumeChange8
TableRVolumeChange(8)
END SUB
SUB TableRFreqChange8
TableRFreqChange(8)
END SUB
SUB TableREnvirChange8
TableREnvirChange(8)
END SUB

SUB TableRNumberChange9
TableRNumberChange(9)
END SUB
SUB TableRVolumeChange9
TableRVolumeChange(9)
END SUB
SUB TableRFreqChange9
TableRFreqChange(9)
END SUB
SUB TableREnvirChange9
TableREnvirChange(9)
END SUB

SUB TableRNumberChange10
TableRNumberChange(10)
END SUB
SUB TableRVolumeChange10
TableRVolumeChange(10)
END SUB
SUB TableRFreqChange10
TableRFreqChange(10)
END SUB
SUB TableREnvirChange10
TableREnvirChange(10)
END SUB

SUB TableRNumberChange11
TableRNumberChange(11)
END SUB
SUB TableRVolumeChange11
TableRVolumeChange(11)
END SUB
SUB TableRFreqChange11
TableRFreqChange(11)
END SUB
SUB TableREnvirChange11
TableREnvirChange(11)
END SUB

SUB TableRNumberChange12
TableRNumberChange(12)
END SUB
SUB TableRVolumeChange12
TableRVolumeChange(12)
END SUB
SUB TableRFreqChange12
TableRFreqChange(12)
END SUB
SUB TableREnvirChange12
TableREnvirChange(12)
END SUB

SUB TableRNumberChange13
TableRNumberChange(13)
END SUB
SUB TableRVolumeChange13
TableRVolumeChange(13)
END SUB
SUB TableRFreqChange13
TableRFreqChange(13)
END SUB
SUB TableREnvirChange13
TableREnvirChange(13)
END SUB

SUB TableRNumberChange14
TableRNumberChange(14)
END SUB
SUB TableRVolumeChange14
TableRVolumeChange(14)
END SUB
SUB TableRFreqChange14
TableRFreqChange(14)
END SUB
SUB TableREnvirChange14
TableREnvirChange(14)
END SUB

SUB TableRNumberChange15
TableRNumberChange(15)
END SUB
SUB TableRVolumeChange15
TableRVolumeChange(15)
END SUB
SUB TableRFreqChange15
TableRFreqChange(15)
END SUB
SUB TableREnvirChange15
TableREnvirChange(15)
END SUB

SUB PlayTableAmb
TMPlength=AmbList(TableScrollSelect.Position).length
TMPlpData = AmbList(TableScrollSelect.Position).lpData
play (TMPlength, TMPlpData)
END SUB
SUB PlayTableRnd(Z AS INTEGER)
TMPlength=RndList(TableScroll(Z).Position).length
TMPlpData = RndList(TableScroll(Z).Position).lpData
play (TMPlength, TMPlpData)
END SUB
SUB PlayTableRnd0
PlayTableRnd(0)
END SUB
SUB PlayTableRnd1
PlayTableRnd(1)
END SUB
SUB PlayTableRnd2
PlayTableRnd(2)
END SUB
SUB PlayTableRnd3
PlayTableRnd(3)
END SUB
SUB PlayTableRnd4
PlayTableRnd(4)
END SUB
SUB PlayTableRnd5
PlayTableRnd(5)
END SUB
SUB PlayTableRnd6
PlayTableRnd(6)
END SUB
SUB PlayTableRnd7
PlayTableRnd(7)
END SUB
SUB PlayTableRnd8
PlayTableRnd(8)
END SUB
SUB PlayTableRnd8
PlayTableRnd(9)
END SUB
SUB PlayTableRnd10
PlayTableRnd(10)
END SUB
SUB PlayTableRnd11
PlayTableRnd(11)
END SUB
SUB PlayTableRnd12
PlayTableRnd(12)
END SUB
SUB PlayTableRnd13
PlayTableRnd(13)
END SUB
SUB PlayTableRnd14
PlayTableRnd(14)
END SUB
SUB PlayTableRnd15
PlayTableRnd(15)
END SUB

FUNCTION RED(Z AS INTEGER) AS BYTE
RESULT=Z AND &HFF
END FUNCTION

FUNCTION GREEN(Z AS INTEGER) AS BYTE
RESULT=(Z SHR 8) AND &HFF
END FUNCTION

FUNCTION BLUE(Z AS INTEGER) AS BYTE
RESULT=(Z SHR 16) AND &HFF
END FUNCTION

SUB ColorChange
  LabelNum1.Caption = STR$(ScrollRed.Position)
  LabelNum2.Caption = STR$(ScrollGreen.Position)
  LabelNum3.Caption = STR$(ScrollBlue.Position)
  RGBPaint
END SUB

SUB RGBPaint
  PaintBox.Paint(0,0,RGB(ScrollRed.Position, ScrollGreen.Position, ScrollBlue.Position), _
                     RGB(ScrollRed.Position, ScrollGreen.Position, ScrollBlue.Position))
END SUB

SUB EditFadeRGB
    SELECT CASE SkyIndex
    CASE 0
    RGBform.Caption="Dawn sky fade color"
ScrollRed.Position=DawnSkyR&
ScrollGreen.Position=DawnSkyG&
ScrollBlue.Position=DawnSkyB&
    CASE 1
    RGBform.Caption="Day sky fade color"
ScrollRed.Position=DaySkyR&
ScrollGreen.Position=DaySkyG&
ScrollBlue.Position=DaySkyB&
    CASE 2
    RGBform.Caption="Night sky fade color"
ScrollRed.Position=NightSkyR&
ScrollGreen.Position=NightSkyG&
ScrollBlue.Position=NightSkyB&
    END SELECT
    SaveColors.OnClick=SaveFadeRGB
    RGBform.Visible=True
    RGBform.Show
END SUB


SUB EditTranspRGB
    SELECT CASE SkyIndex
    CASE 0
    RGBform.Caption="Dawn sky transparency color"
    ScrollRed.Position=DawnSkyTR&
ScrollGreen.Position=DawnSkyTG&
ScrollBlue.Position=DawnSkyTB&
    CASE 1
    RGBform.Caption="Day sky transparency color"
ScrollRed.Position=DaySkyTR&
ScrollGreen.Position=DaySkyTG&
ScrollBlue.Position=DaySkyTB&
    CASE 2
    RGBform.Caption="Night sky transparency color"
ScrollRed.Position=NightSkyTR&
ScrollGreen.Position=NightSkyTG&
ScrollBlue.Position=NightSkyTB&
    END SELECT
    SaveColors.OnClick=SaveTranspRGB
    RGBform.Visible=True
    RGBform.Show
END SUB


SUB SaveFadeRGB
    SELECT CASE SkyIndex
    CASE 0
DawnSkyR&=ScrollRed.Position
DawnSkyG&=ScrollGreen.Position
DawnSkyB&=ScrollBlue.Position
    CASE 1
DaySkyR&=ScrollRed.Position
DaySkyG&=ScrollGreen.Position
DaySkyB&=ScrollBlue.Position
    CASE 2
NightSkyR&=ScrollRed.Position
NightSkyG&=ScrollGreen.Position
NightSkyB&=ScrollBlue.Position
    END SELECT
    RGBform.Close
END SUB


SUB SaveTranspRGB
    SELECT CASE SkyIndex
    CASE 0
DawnSkyTR&=ScrollRed.Position
DawnSkyTG&=ScrollGreen.Position
DawnSkyTB&=ScrollBlue.Position
    CASE 1
DaySkyTR&=ScrollRed.Position
DaySkyTG&=ScrollGreen.Position
DaySkyTB&=ScrollBlue.Position
    CASE 2
NightSkyTR&=ScrollRed.Position
NightSkyTG&=ScrollGreen.Position
NightSkyTB&=ScrollBlue.Position
    END SELECT
    RGBform.Close
END SUB

SUB CloseRGBcolors
    RGBform.Close
END SUB


SUB FogNumberChange
FogIndex=FogScrollSelect.Position
  FogLabelNum0.Caption = STR$(FogIndex)
FogRGB=FogsList(FogIndex).fogRGB
FogScrollRed.Position=(FogRGB) AND &HFF
FogScrollGreen.Position=(FogRGB SHR 8) AND &HFF
FogScrollBlue.Position=(FogRGB SHR 16) AND &HFF
FogScrollYBegin.Position=FogsList(FogIndex).YBegin
FogCheckboxMortal.Checked=FogsList(FogIndex).Mortal
FogScrollTransp.Position=FogsList(FogIndex).Transp
FogScrollFLimit.Position=FogsList(FogIndex).FLimit
  FogRGBPaint
END SUB

SUB FogColorChange
  FogLabelNum1.Caption = STR$(FogScrollRed.Position)
  FogLabelNum2.Caption = STR$(FogScrollGreen.Position)
  FogLabelNum3.Caption = STR$(FogScrollBlue.Position)
  FogRGBPaint
END SUB

SUB FogYBeginChange
  FogLabelNumY.Caption = STR$(FogScrollYBegin.Position)
END SUB
  

SUB FogTranspChange
  FogLabelNumTransp.Caption = STR$(FogScrollTransp.Position)
END SUB
  

SUB FogFLimitChange
  FogLabelNumFLimit.Caption = STR$(FogScrollFLimit.Position)
END SUB
  

SUB FogRGBPaint
  FogPaintBox.Paint(0,0,RGB(FogScrollRed.Position, FogScrollGreen.Position, FogScrollBlue.Position), _
                     RGB(FogScrollRed.Position, FogScrollGreen.Position, FogScrollBlue.Position))
END SUB


SUB EditFogForm
FogScrollSelect.Position=FogIndex
FogRGB=FogsList(FogIndex).fogRGB
FogScrollRed.Position=(FogRGB) AND &HFF
FogScrollGreen.Position=(FogRGB SHR 8) AND &HFF
FogScrollBlue.Position=(FogRGB SHR 16) AND &HFF
FogScrollYBegin.Position=FogsList(FogIndex).YBegin
FogCheckboxMortal.Checked=FogsList(FogIndex).Mortal
FogScrollTransp.Position=FogsList(FogIndex).Transp
FogScrollFLimit.Position=FogsList(FogIndex).FLimit
    FogForm.Visible=True
    FogForm.Show
END SUB

SUB SaveFogForm
FogIndex=FogScrollSelect.Position
FogRGB=RGB(FogScrollRed.Position,FogScrollGreen.Position,FogScrollBlue.Position)
FogsList(FogIndex).fogRGB=FogRGB
FogsList(FogIndex).YBegin=FogScrollYBegin.Position
FogsList(FogIndex).Mortal=FogCheckboxMortal.Checked
FogsList(FogIndex).Transp=FogScrollTransp.Position
FogsList(FogIndex).FLimit=FogScrollFLimit.Position
END SUB

SUB CloseFogForm
    FogForm.Close
END SUB


SUB WaterNumberChange
WaterIndex=WaterScrollSelect.Position
  WaterLabelNum0.Caption = STR$(WaterIndex)
WaterRGB=WaterList(WaterIndex).fogRGB
WaterScrollRed.Position=(WaterRGB) AND &HFF
WaterScrollGreen.Position=(WaterRGB SHR 8) AND &HFF
WaterScrollBlue.Position=(WaterRGB SHR 16) AND &HFF
WaterScrollWlevel.Position=WaterList(WaterIndex).Wlevel
WaterScrollTransp.Position=INT((WaterList(WaterIndex).Transp+0.005)*10)
'  WaterLabelNumTransp.Caption = STR$(WaterList(WaterIndex).Transp)
WaterScrollTindex.Position=WaterList(WaterIndex).Tindex
  WaterRGBPaint
  WaterTexPaint
END SUB

SUB WaterColorChange
  WaterLabelNum1.Caption = STR$(WaterScrollRed.Position)
  WaterLabelNum2.Caption = STR$(WaterScrollGreen.Position)
  WaterLabelNum3.Caption = STR$(WaterScrollBlue.Position)
  WaterRGBPaint
END SUB

SUB WaterWlevelChange
  WaterLabelNumWlevel.Caption = STR$(WaterScrollWlevel.Position)
END SUB
  

SUB WaterTranspChange
  WaterLabelNumTransp.Caption = STR$(WaterScrollTransp.Position/10)
END SUB
  

SUB WaterTindexChange
  WaterLabelNumTindex.Caption = STR$(WaterScrollTindex.Position)
  WaterTexPaint
END SUB
  

SUB WaterRGBPaint
  WaterPaintBox.Paint(0,0,RGB(WaterScrollRed.Position, WaterScrollGreen.Position, WaterScrollBlue.Position), _
                     RGB(WaterScrollRed.Position, WaterScrollGreen.Position, WaterScrollBlue.Position))
END SUB


SUB WaterTexPaint
DIM Destination AS QRECT
DIM Source AS QRECT
'  WaterTextureBox.Paint(0,0,RGB(WaterScrollRed.Position, WaterScrollGreen.Position, WaterScrollBlue.Position), _
'                     RGB(WaterScrollRed.Position, WaterScrollGreen.Position, WaterScrollBlue.Position))
DIM Z AS INTEGER                     
Z=WaterScrollTindex.Position
WITH Destination
.Left = 0
.Right = 128
.Top = 0
.Bottom = 128
END WITH
WITH Source
.Left = 0
.Right = 128
.Top = 128*Z
.Bottom = .Top + 128
END WITH
WaterTextureBox.CopyRect(Destination, TextureList, Source)

' WaterTextureBox.Visible = True
'WaterTextureBox.Repaint
END SUB


SUB EditWaterForm
WaterScrollSelect.Position=WaterIndex
WaterRGB=WaterList(WaterIndex).fogRGB
WaterScrollRed.Position=(WaterRGB) AND &HFF
WaterScrollGreen.Position=(WaterRGB SHR 8) AND &HFF
WaterScrollBlue.Position=(WaterRGB SHR 16) AND &HFF
WaterScrollWlevel.Position=WaterList(WaterIndex).Wlevel
WaterScrollTransp.Position=INT((WaterList(WaterIndex).Transp+0.005)*10)
'  WaterLabelNumTransp.Caption = STR$(WaterList(WaterIndex).Transp)
WaterScrollTindex.Position=WaterList(WaterIndex).Tindex
    WaterForm.Visible=True
    WaterForm.Show
END SUB

SUB SaveWaterForm
WaterIndex=WaterScrollSelect.Position
WaterRGB=RGB(WaterScrollRed.Position,WaterScrollGreen.Position,WaterScrollBlue.Position)
WaterList(WaterIndex).fogRGB=WaterRGB
WaterList(WaterIndex).Wlevel=WaterScrollWlevel.Position
WaterList(WaterIndex).Transp=WaterScrollTransp.Position/10
WaterList(WaterIndex).Tindex=WaterScrollTindex.Position
END SUB

SUB CloseWaterForm
    WaterForm.Close
END SUB

SUB CloseObjForm
    ObjForm.Close
END SUB


SUB DrawTexture (Z AS INTEGER)
DIM Destination AS QRECT
DIM Source AS QRECT
Canvas.Visible = False

Form1.Color = 0

WITH Destination
.Left = 0
.Right = 128
.Top = 0
.Bottom = 128
END WITH
WITH Source
.Left = 0
.Right = 128
.Top = 128*Z
.Bottom = .Top + 128
END WITH
Bitmap.CopyRect(Destination, TextureList, Source)

Canvas.Visible = True
' Canvas.Repaint
Canvas.ShowHint=True
Form1.Show

END SUB
 

SUB PlayRnd
    TMPlength=RndList(RndIndex).length
    TMPlpData=RndList(RndIndex).lpData
    Status1.SimpleText="Playing random sound "+STR$(RndIndex+1)
    play (TMPlength, TMPlpData)
END SUB

SUB SaveRnd
    TMPlength=RndList(RndIndex).length
    TMPlpData=RndList(RndIndex).lpData

  SaveWavDialog.InitialDir = CurDir$
  SaveWavDialog.Mode=fdSave
  SaveWavDialog.WarnIfOverwrite=1
'  SaveWavDialog.FileName=TMPsfxName
  SaveWavDialog.Filter = "WAV Files (*.wav)|*.wav"

  IF SaveWavDialog.Execute THEN
    FileName$=SaveWavDialog.FileName
  IF INSTR(FileName$,".wav") = 0 THEN FileName$=FileName$+".wav"
'    Status1.SimpleText="Saving "+FileName$
    saveWav(FileName$, TMPlength, TMPlpData)
    Status1.SimpleText="Saved random sound "+STR$(RndIndex+1)+" as "+FileName$
   END IF
'    play (TMPlength, TMPlpData)
END SUB

SUB LoadRnd

  LoadWavDialog.InitialDir = CurDir$
  LoadWavDialog.Filter = "WAV Files (*.wav)|*.wav"

    IF LoadWavDialog.Execute THEN
        FileName$=LoadWavDialog.FileName
 '    Status1.SimpleText="Saving "+FileName$
    loadWav(FileName$,0)
    END IF
'    play (TMPlength, TMPlpData)
END SUB


SUB PlayAmb
    TMPlength=AmbList(AmbIndex).length
    TMPlpData=AmbList(AmbIndex).lpData
    Status1.SimpleText="Playing ambient sound "+STR$(AmbIndex+1)
    play (TMPlength, TMPlpData)
END SUB

SUB SaveAmb
    TMPlength=AmbList(AmbIndex).length
    TMPlpData=AmbList(AmbIndex).lpData

  SaveWavDialog.InitialDir = CurDir$
  SaveWavDialog.Mode=fdSave
  SaveWavDialog.WarnIfOverwrite=1
'  SaveWavDialog.FileName=TMPsfxName
  SaveWavDialog.Filter = "WAV Files (*.wav)|*.wav"

  IF SaveWavDialog.Execute THEN
    FileName$=SaveWavDialog.FileName
  IF INSTR(FileName$,".wav") = 0 THEN FileName$=FileName$+".wav"
'    Status1.SimpleText="Saving "+FileName$
    saveWav(FileName$, TMPlength, TMPlpData)
    Status1.SimpleText="Saved ambient sound "+STR$(AmbIndex+1)+" as "+FileName$
   END IF
'    play (TMPlength, TMPlpData)
END SUB

SUB LoadAmb

  LoadWavDialog.InitialDir = CurDir$
  LoadWavDialog.Filter = "WAV Files (*.wav)|*.wav"

    IF LoadWavDialog.Execute THEN
        FileName$=LoadWavDialog.FileName
 '    Status1.SimpleText="Saving "+FileName$
    loadWav(FileName$,1)
    Status1.SimpleText="Replaced ambient sound "+STR$(AmbIndex)
    END IF
'    play (TMPlength, TMPlpData)
END SUB

SUB ImportTGA (Image AS INTEGER)

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "TGA Files (*.tga)|*.tga"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadTGA (Image)

      END IF
END SUB

SUB ExportTGA (Image AS INTEGER)

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "TGA Files (*.tga)|*.tga"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".tga") = 0 THEN FileName$=FileName$+".tga"
    Status1.SimpleText="Exporting "+FileName$
    SaveTGA (Image)
      END IF    
END SUB

SUB LoadTGA (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
TextureSize=32768
CASE 1
MustWidth%=256
MustHeight%=256
TextureSize=131072
CASE 2
MustWidth%=128
MustHeight%=128
TextureSize=32768
CASE ELSE
GOTO AbortLoadTGA
END SELECT

DIM TGAidentsize?
DIM TGAcolourmaptype?
DIM TGAimagetype?
DIM TGAcolourmapstart%
DIM TGAcolourmaplength%
DIM TGAcolourmapbits?
DIM TGAxstart%
DIM TGAystart%
DIM TGAwidth%
DIM TGAheight%
DIM TGAbits?
DIM TGAdescriptor?

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
IF File.Size<>18+TextureSize THEN SHOWMESSAGE "WARNING: Not an uncompressed "+STR$(MustWidth%)+"x"+STR$(MustHeight%)+" 16-bit TGA 1.0 image!" ':GOTO AbortLoadTGA

Status1.SimpleText="Reading Header..."
Form1.Show
File.Read(TGAidentsize?)
IF TGAidentsize?<>0 THEN SHOWMESSAGE "ID field present.":GOTO AbortLoadTGA
File.Read(TGAcolourmaptype?)
IF TGAcolourmaptype?<>0 THEN SHOWMESSAGE "Wrong colour map type.":GOTO AbortLoadTGA
File.Read(TGAimagetype?)
IF TGAimagetype?<>2 THEN SHOWMESSAGE "Not an RGB image.":GOTO AbortLoadTGA
File.Read(TGAcolourmapstart%)
IF TGAcolourmapstart%<>0 THEN SHOWMESSAGE "First palette entry should be set to 0.":GOTO AbortLoadTGA
File.Read(TGAcolourmaplength%)
IF TGAcolourmaplength%<>0 THEN SHOWMESSAGE "Colour map present.":GOTO AbortLoadTGA
File.Read(TGAcolourmapbits?)
IF TGAcolourmapbits?<>0 THEN SHOWMESSAGE "Should be 0 bits per palette entry.":GOTO AbortLoadTGA
File.Read(TGAxstart%)
IF TGAxstart%<>0 THEN SHOWMESSAGE "X origin should be 0.":GOTO AbortLoadTGA
File.Read(TGAystart%)
IF TGAystart%<>0 THEN SHOWMESSAGE "Y origin should be 0.":GOTO AbortLoadTGA
File.Read(TGAwidth%)
IF TGAwidth%<>MustWidth% THEN SHOWMESSAGE "Image isn't "+STR$(MustWidth%)+" pixels wide.":GOTO AbortLoadTGA
File.Read(TGAheight%)
IF TGAheight%<>MustHeight% THEN SHOWMESSAGE "Image isn't "+STR$(MustHeight%)+" pixels tall.":GOTO AbortLoadTGA
File.Read(TGAbits?)
IF TGAbits?<>16 THEN SHOWMESSAGE "Not a 16-bit image.":GOTO AbortLoadTGA
File.Read(TGAdescriptor?)
IF TGAdescriptor?<>0 THEN SHOWMESSAGE "Image is flipped or has alpha bits set.":GOTO AbortLoadTGA
Status1.SimpleText="Reading scanlines..."
Form1.Show

SELECT CASE Image
CASE 0
FOR X = 0 TO 127
File.LoadArray(TEX??(128 -X -1, 0),128)
NEXT X
InitScreen
StoreBitmap(TexIndex)
TexPaint

CASE 1
FOR X = 0 TO 255
SELECT CASE SkyIndex
CASE 0
File.LoadArray(DawnSky(256 -X -1,0),256)
CASE 1
File.LoadArray(DaySky(256 -X -1,0),256)
CASE 2
File.LoadArray(NightSky(256 -X -1,0),256)
END SELECT
NEXT X
DrawSky555(SkyIndex)
DrawSky(SkyIndex)

CASE 2
FOR X = 0 TO 127
File.LoadArray(TEX??(128 -X -1, 0),128)
NEXT X
GreyscaleSkyLight
StoreSkyLight
DrawSkyLight


END SELECT


Status1.SimpleText="Done"
AbortLoadTGA:
Form1.Show
File.Close



END SUB

SUB SaveTGA (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
CASE 1
MustWidth%=256
MustHeight%=256
CASE 2
MustWidth%=128
MustHeight%=128
END SELECT

DIM TGAidentsize?
DIM TGAcolourmaptype?
DIM TGAimagetype?
DIM TGAcolourmapstart%
DIM TGAcolourmaplength%
DIM TGAcolourmapbits?
DIM TGAxstart%
DIM TGAystart%
DIM TGAwidth%
DIM TGAheight%
DIM TGAbits?
DIM TGAdescriptor?

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header..."
Form1.Show
TGAidentsize?=0:File.Write(TGAidentsize?)
TGAcolourmaptype?=0:File.Write(TGAcolourmaptype?)
TGAimagetype?=2:File.Write(TGAimagetype?)
TGAcolourmapstart%=0:File.Write(TGAcolourmapstart%)
TGAcolourmaplength%=0:File.Write(TGAcolourmaplength%)
TGAcolourmapbits?=0:File.Write(TGAcolourmapbits?)
TGAxstart%=0:File.Write(TGAxstart%)
TGAystart%=0:File.Write(TGAystart%)
TGAwidth%=MustWidth%:File.Write(TGAwidth%)
TGAheight%=MustHeight%:File.Write(TGAheight%)
TGAbits?=16:File.Write(TGAbits?)
TGAdescriptor?=0:File.Write(TGAdescriptor?)
Status1.SimpleText="Writing scanlines..."
Form1.Show

SELECT CASE Image
CASE 0
' RGBto555
RetrieveBitmap(TexIndex)
FOR X = 0 TO 127
File.SaveArray(TEX??(128 -X -1, 0),128)
NEXT X

CASE 1
FOR X = 0 TO 255
SELECT CASE SkyIndex
CASE 0
File.SaveArray(DawnSky(256 -X -1,0),256)
CASE 1
File.SaveArray(DaySky(256 -X -1,0),256)
CASE 2
File.SaveArray(NightSky(256 -X -1,0),256)
END SELECT
NEXT X

CASE 2
SkyLightTo555
FOR X = 0 TO 127
File.SaveArray(TEX??(128 -X -1, 0),128)
NEXT X


END SELECT

Status1.SimpleText="Done"
Form1.Show
File.Close

END SUB

SUB ExportBMP16 (Image AS INTEGER)

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "BMP Files (*.bmp)|*.bmp"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
      FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".bmp") = 0 THEN FileName$=FileName$+".bmp"
    Status1.SimpleText="Exporting "+FileName$
    SaveBMP16 (Image)
  END IF
END SUB

SUB SaveBMP16 (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
TextureSize=32768
CASE 1
MustWidth%=256
MustHeight%=256
TextureSize=131072
CASE 2
MustWidth%=128
MustHeight%=128
TextureSize=32768
END SELECT

DIM BMSignature$ AS STRING * 2
DIM BMFileSize&
DIM BMreserved&
DIM BMDataOffset&
DIM BMSize&
DIM BMWidth&
DIM BMHeight&
DIM BMPlanes%
DIM BMBitCount%
DIM BMCompression&
DIM BMImageSize&
DIM BMXpixelsPerM&
DIM BMYpixelsPerM&
DIM BMColorsUsed&
DIM BMColorsImportant&

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header..."
Form1.Show
BMSignature$="BM":File.WriteStr(BMSignature$,2)
BMFileSize&=&H36+TextureSize:File.Write(BMFileSize&)
BMreserved&=0:File.Write(BMreserved&)
BMDataOffset&=&H36:File.Write(BMDataOffset&)
BMSize&=&H28:File.Write(BMSize&)
BMWidth&=MustWidth%:File.Write(BMWidth&)
BMHeight&=MustHeight%:File.Write(BMHeight&)
BMPlanes%=1:File.Write(BMPlanes%)
BMBitCount%=16:File.Write(BMBitCount%)
BMCompression&=0:File.Write(BMCompression&)
BMImageSize&=0:File.Write(BMImageSize&)
BMXpixelsPerM&=1:File.Write(BMXpixelsPerM&)
BMYpixelsPerM&=1:File.Write(BMYpixelsPerM&)
BMColorsUsed&=&H1000000:File.Write(BMColorsUsed&)
BMColorsImportant&=0:File.Write(BMColorsImportant&)
Status1.SimpleText="Writing scanlines..."
Form1.Show

SELECT CASE Image
CASE 0
' RGBto555
RetrieveBitmap(TexIndex)
FOR X = 0 TO 127
File.SaveArray(TEX??(128 -X -1, 0),128)
NEXT X

CASE 1
FOR X = 0 TO 255
SELECT CASE SkyIndex
CASE 0
File.SaveArray(DawnSky(256 -X -1,0),256)
CASE 1
File.SaveArray(DaySky(256 -X -1,0),256)
CASE 2
File.SaveArray(NightSky(256 -X -1,0),256)
END SELECT
NEXT X

CASE 2
SkyLightTo555
FOR X = 0 TO 127
File.SaveArray(TEX??(128 -X -1, 0),128)
NEXT X


END SELECT

Status1.SimpleText="Done"
Form1.Show
File.Close

END SUB


SUB ImportBMP16 (Image AS INTEGER)

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "BMP Files (*.bmp)|*.bmp"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadBMP16 (Image)
  END IF
END SUB

SUB LoadBMP16 (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
TextureSize=32768
CASE 1
MustWidth%=256
MustHeight%=256
TextureSize=131072
CASE 2
MustWidth%=128
MustHeight%=128
TextureSize=32768
CASE ELSE
GOTO AbortLoadBMP16
END SELECT

DIM BMSignature$ AS STRING * 2
DIM BMFileSize&
DIM BMreserved&
DIM BMDataOffset&
DIM BMSize&
DIM BMWidth&
DIM BMHeight&
DIM BMPlanes%
DIM BMBitCount%
DIM BMCompression&
DIM BMImageSize&
DIM BMXpixelsPerM&
DIM BMYpixelsPerM&
DIM BMColorsUsed&
DIM BMColorsImportant&

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
Status1.SimpleText="Reading Header..."
Form1.Show
BMSignature$=File.ReadStr(2)
IF LEFT$(BMSignature$,2)<>"BM" THEN SHOWMESSAGE "Not a BMP image!":GOTO AbortLoadBMP16
File.Read(BMFileSize&)
IF BMFileSize&<>&H36+TextureSize THEN SHOWMESSAGE "BMP has wrong filesize.":GOTO AbortLoadBMP16
File.Read(BMreserved&)
'IF BMreserved&<>0 THEN SHOWMESSAGE "Reserved byte isn't 0.":GOTO AbortLoadBMP16
File.Read(BMDataOffset&)
IF BMDataOffset&<>&H36 THEN SHOWMESSAGE "Wrong data offset.":GOTO AbortLoadBMP16
File.Read(BMSize&)
IF BMSize&<>&H28 THEN SHOWMESSAGE "BMP has wrong header size.":GOTO AbortLoadBMP16
File.Read(BMWidth&)
IF BMWidth&<>MustWidth% THEN SHOWMESSAGE "BMP isn't "+STR$(MustWidth%)+" pixels wide.":GOTO AbortLoadBMP16
File.Read(BMHeight&)
IF BMHeight&<>MustHeight% THEN SHOWMESSAGE "BMP isn't "+STR$(MustHeight%)+" pixels tall.":GOTO AbortLoadBMP16
File.Read(BMPlanes%)
IF BMPlanes%<>1 THEN SHOWMESSAGE "BMP has more than 1 plane.":GOTO AbortLoadBMP16
File.Read(BMBitCount%)
IF BMBitCount%<>16 THEN SHOWMESSAGE "BMP doesn't have a 16-bit color depth.":GOTO AbortLoadBMP16
File.Read(BMCompression&)
IF BMCompression&<>0 THEN SHOWMESSAGE "BMP isn't uncompressed.":GOTO AbortLoadBMP16
File.Read(BMImageSize&)
' IF BMImageSize&<>0  THEN SHOWMESSAGE "BMP size not set to 0.":GOTO AbortLoadBMP16
File.Read(BMXpixelsPerM&)
'IF BMXpixelsPerM&<>1 THEN SHOWMESSAGE "BMP horizontal resolution isn't 1 pixel/m.":GOTO AbortLoadBMP16
File.Read(BMYpixelsPerM&)
'IF BMYpixelsPerM&<>1 THEN SHOWMESSAGE "BMP vertical resolution isn't 1 pixel/m.":GOTO AbortLoadBMP16
File.Read(BMColorsUsed&)
'IF BMColorsUsed&<>&H1000000 THEN SHOWMESSAGE "BMP doesn't use 16 million colors.":GOTO AbortLoadBMP16
File.Read(BMColorsImportant&)
'IF BMColorsImportant&<>0 THEN SHOWMESSAGE "BMP has important colors set.":GOTO AbortLoadBMP16

Status1.SimpleText="Reading scanlines..."
Form1.Show
SELECT CASE Image
CASE 0
FOR X = 0 TO 127
File.LoadArray(TEX??(128 -X -1, 0),128)
NEXT X
InitScreen
StoreBitmap(TexIndex)
TexPaint

CASE 1
FOR X = 0 TO 255
SELECT CASE SkyIndex
CASE 0
File.LoadArray(DawnSky(256 -X -1,0),256)
CASE 1
File.LoadArray(DaySky(256 -X -1,0),256)
CASE 2
File.LoadArray(NightSky(256 -X -1,0),256)
END SELECT
NEXT X
DrawSky555(SkyIndex)
DrawSky(SkyIndex)

CASE 2
FOR X = 0 TO 127
File.LoadArray(TEX??(128 -X -1, 0),128)
NEXT X
GreyscaleSkyLight
StoreSkyLight
DrawSkyLight


END SELECT


Status1.SimpleText="Done"
AbortLoadBMP16:
Form1.Show
File.Close

END SUB


SUB ExportBMP32 (Image AS INTEGER)

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "BMP Files (*.bmp)|*.bmp"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".bmp") = 0 THEN FileName$=FileName$+".bmp"
    Status1.SimpleText="Exporting "+FileName$
    SaveBMP32 (Image)
  END IF
END SUB

SUB SaveBMP32 (Image AS INTEGER)

SELECT CASE Image
CASE 0
RetrieveBitmap(TexIndex)
DrawPicture555
BitMap.SaveToFile(FileName$)

CASE 1
SkyBitMap.SaveToFile(FileName$)

CASE 2
SkyLightBitMap.SaveToFile(FileName$)

END SELECT

Status1.SimpleText="Done"
Form1.Show

END SUB


SUB ImportBMP32 (Image AS INTEGER)

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "BMP Files (*.bmp)|*.bmp"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadBMP32 (Image)
  END IF
END SUB

SUB LoadBMP32 (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
CASE 1
MustWidth%=256
MustHeight%=256
CASE 2
MustWidth%=128
MustHeight%=128
CASE ELSE
GOTO AbortLoadBMP32
END SELECT

DIM BMSignature$ AS STRING * 2
DIM BMFileSize&
DIM BMreserved&
DIM BMDataOffset&
DIM BMSize&
DIM BMWidth&
DIM BMHeight&
DIM BMPlanes%
DIM BMBitCount%
DIM BMCompression&
DIM BMImageSize&
DIM BMXpixelsPerM&
DIM BMYpixelsPerM&
DIM BMColorsUsed&
DIM BMColorsImportant&

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
Status1.SimpleText="Reading Header..."
Form1.Show
BMSignature$=File.ReadStr(2)
File.Read(BMFileSize&)
File.Read(BMreserved&)
File.Read(BMDataOffset&)
File.Read(BMSize&)
File.Read(BMWidth&)
File.Read(BMHeight&)
File.Read(BMPlanes%)
File.Read(BMBitCount%)
File.Read(BMCompression&)
File.Read(BMImageSize&)
File.Read(BMXpixelsPerM&)
File.Read(BMYpixelsPerM&)
File.Read(BMColorsUsed&)
File.Read(BMColorsImportant&)
File.close

IF LEFT$(BMSignature$,2)<>"BM" THEN SHOWMESSAGE "Not a BMP image!":GOTO AbortLoadBMP32
'IF BMFileSize&<>&H36+TextureSize THEN SHOWMESSAGE "BMP has wrong filesize.":GOTO AbortLoadBMP32
'IF BMreserved&<>0 THEN SHOWMESSAGE "Reserved byte isn't 0.":GOTO AbortLoadBMP32
IF BMDataOffset&<>&H36 THEN SHOWMESSAGE "Wrong data offset.":GOTO AbortLoadBMP32
IF BMSize&<>&H28 THEN SHOWMESSAGE "BMP has wrong header size.":GOTO AbortLoadBMP32
IF BMWidth&<>MustWidth% THEN SHOWMESSAGE "BMP isn't "+STR$(MustWidth%)+" pixels wide.":GOTO AbortLoadBMP32
IF BMHeight&<>MustHeight% THEN SHOWMESSAGE "BMP isn't "+STR$(MustHeight%)+" pixels tall.":GOTO AbortLoadBMP32
IF BMPlanes%<>1 THEN SHOWMESSAGE "BMP has more than 1 plane.":GOTO AbortLoadBMP32
IF BMBitCount%<>32 AND BMBitCount%<>24 THEN SHOWMESSAGE "BMP doesn't have a 24- or 32-bit color depth.":GOTO AbortLoadBMP32
IF BMCompression&<>0 THEN SHOWMESSAGE "BMP isn't uncompressed.":GOTO AbortLoadBMP32
' IF BMImageSize&<>0  THEN SHOWMESSAGE "BMP size not set to 0.":GOTO AbortLoadBMP32
'IF BMXpixelsPerM&<>1 THEN SHOWMESSAGE "BMP horizontal resolution isn't 1 pixel/m.":GOTO AbortLoadBMP32
'IF BMYpixelsPerM&<>1 THEN SHOWMESSAGE "BMP vertical resolution isn't 1 pixel/m.":GOTO AbortLoadBMP32
'IF BMColorsUsed&<>&H1000000 THEN SHOWMESSAGE "BMP doesn't use 16 million colors.":GOTO AbortLoadBMP32
'IF BMColorsImportant&<>0 THEN SHOWMESSAGE "BMP has important colors set.":GOTO AbortLoadBMP32

Status1.SimpleText="Reading scanlines..."
Form1.Show
SELECT CASE Image
CASE 0
BitMap.LoadFromFile(FileName$)
RGBto555
InitScreen
StoreBitmap(TexIndex)
TexPaint

CASE 1
SkyBitMap.LoadFromFile(FileName$)
SkyRGBto555(SkyIndex)
DrawSky555(SkyIndex)
DrawSky(SkyIndex)

CASE 2
SkyLightBitMap.LoadFromFile(FileName$)
SkyLightRGBto555
GreyscaleSkyLight
StoreSkyLight
DrawSkyLight

END SELECT

Status1.SimpleText="Done"
AbortLoadBMP32:
Form1.Show

END SUB



SUB ExportJPG (Image AS INTEGER)

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "JPEG Files (*.jpg)|*.jpg"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
      FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".jpg") = 0 THEN FileName$=FileName$+".jpg"
    Status1.SimpleText="Exporting "+FileName$
    SaveJPG (Image)
  END IF
END SUB

SUB SaveJPG (Image AS INTEGER)

SELECT CASE Image
CASE 0
RetrieveBitmap(TexIndex)
DrawPicture555
XBitMap.Height=128
XBitMap.Width=128
XBitMap.BMP=BitMap.BMP

CASE 1
XBitMap.Height=256
XBitMap.Width=256
XBitMap.BMP=SkyBitMap.BMP

CASE 2
XBitMap.Height=128
XBitMap.Width=128
XBitMap.BMP=SkyLightBitMap.BMP

END SELECT

XBitMap.SaveAsJpg(FileName$,100)

Status1.SimpleText="Done"
Form1.Show

END SUB


SUB ImportJPG (Image AS INTEGER)

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "Picture files|*.BMP;*.ICO;*.JPG;*.GIF;*.DIB;*.RLE;*.TGA;*.PCX"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadJPG (Image)
  END IF
END SUB


SUB LoadJPG (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
CASE 1
MustWidth%=256
MustHeight%=256
CASE 2
MustWidth%=128
MustHeight%=128
CASE ELSE
GOTO AbortLoadJPG
END SELECT

Status1.SimpleText="Reading image..."
Form1.Show
XBitMap.LoadOtherImage(FileName$,True,"English")
IF XbitMap.Width<>MustWidth% THEN SHOWMESSAGE "image isn't "+STR$(MustWidth%)+" pixels wide.":GOTO AbortLoadJPG
IF XBitMap.Height<>MustHeight% THEN SHOWMESSAGE "image isn't "+STR$(MustHeight%)+" pixels tall.":GOTO AbortLoadJPG
Status1.SimpleText="Processing image..."
Form1.Show

SELECT CASE Image
CASE 0
Canvas.Draw(0,0,XBitMap.BMP)
BitMap.BMP=XBitMap.BMP
RGBto555
InitScreen
StoreBitmap(TexIndex)
TexPaint

CASE 1
SkyCanvas.Draw(0,0,XBitMap.BMP)
SkyBitMap.BMP=XBitMap.BMP
SkyRGBto555(SkyIndex)
DrawSky555(SkyIndex)
DrawSky(SkyIndex)

CASE 2
SkyLightCanvas.Draw(0,0,XBitMap.BMP)
SkyLightBitMap.BMP=XBitMap.BMP
SkyLightRGBto555
GreyscaleSkyLight
StoreSkyLight
DrawSkyLight

END SELECT

Status1.SimpleText="Done"
AbortLoadJPG:
Form1.Show

END SUB


SUB ExportBMPgrey

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "BMP Files (*.bmp)|*.bmp"
'  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
'  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".bmp") = 0 THEN FileName$=FileName$+".bmp"
    Status1.SimpleText="Exporting "+FileName$
    SaveBMPgrey
  END IF
END SUB

SUB SaveBMPgrey

MustWidth%=128
MustHeight%=128
TextureSize=16384

DIM BMSignature$ AS STRING * 2
DIM BMFileSize&
DIM BMreserved&
DIM BMDataOffset&
DIM BMSize&
DIM BMWidth&
DIM BMHeight&
DIM BMPlanes%
DIM BMBitCount%
DIM BMCompression&
DIM BMImageSize&
DIM BMXpixelsPerM&
DIM BMYpixelsPerM&
DIM BMColorsUsed&
DIM BMColorsImportant&
DIM Palette&

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header..."
Form1.Show
BMSignature$="BM":File.WriteStr(BMSignature$,2)
BMFileSize&=&H436+TextureSize:File.Write(BMFileSize&)
BMreserved&=0:File.Write(BMreserved&)
BMDataOffset&=&H436:File.Write(BMDataOffset&)
BMSize&=&H28:File.Write(BMSize&)
BMWidth&=MustWidth%:File.Write(BMWidth&)
BMHeight&=MustHeight%:File.Write(BMHeight&)
BMPlanes%=1:File.Write(BMPlanes%)
BMBitCount%=8:File.Write(BMBitCount%)
BMCompression&=0:File.Write(BMCompression&)
BMImageSize&=0:File.Write(BMImageSize&)
BMXpixelsPerM&=1:File.Write(BMXpixelsPerM&)
BMYpixelsPerM&=1:File.Write(BMYpixelsPerM&)
BMColorsUsed&=&H100:File.Write(BMColorsUsed&)
BMColorsImportant&=0:File.Write(BMColorsImportant&)
'BMColorTable$=File.ReadBinStr(1024)
FOR X=0 TO 255
Palette&=X*&H10101
File.Write(Palette&)
NEXT X
Status1.SimpleText="Writing scanlines..."
Form1.Show

FOR X = 0 TO 127
File.SaveArray(SkyLight(127-X, 0),128)
NEXT X

Status1.SimpleText="Done"
Form1.Show
File.Close

END SUB

SUB ImportBMPgrey

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "BMP Files (*.bmp)|*.bmp"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadBMPgrey
  END IF
END SUB

SUB LoadBMPgrey

MustWidth%=128
MustHeight%=128
TextureSize=16384

DIM BMSignature$ AS STRING * 2
DIM BMFileSize&
DIM BMreserved&
DIM BMDataOffset&
DIM BMSize&
DIM BMWidth&
DIM BMHeight&
DIM BMPlanes%
DIM BMBitCount%
DIM BMCompression&
DIM BMImageSize&
DIM BMXpixelsPerM&
DIM BMYpixelsPerM&
DIM BMColorsUsed&
DIM BMColorsImportant&
DIM BMColorTable$ AS STRING * 1024

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
IF File.Size<>&H436+TextureSize THEN SHOWMESSAGE "WARNING: Not an uncompressed "+STR$(MustWidth%)+"x"+STR$(MustHeight%)+" 8-bit BMP image!" ':GOTO AbortLoadBMPgrey

Status1.SimpleText="Reading Header..."
Form1.Show
BMSignature$=File.ReadStr(2)
IF LEFT$(BMSignature$,2)<>"BM" THEN SHOWMESSAGE "Not a BMP image!":GOTO AbortLoadBMPgrey
File.Read(BMFileSize&)
IF BMFileSize&<>&H436+TextureSize THEN SHOWMESSAGE "BMP has wrong filesize.":GOTO AbortLoadBMPgrey
File.Read(BMreserved&)
'IF BMreserved&<>0 THEN SHOWMESSAGE "Reserved byte isn't 0.":GOTO AbortLoadBMPgrey
File.Read(BMDataOffset&)
IF BMDataOffset&<>&H436 THEN SHOWMESSAGE "Wrong data offset.":GOTO AbortLoadBMPgrey
File.Read(BMSize&)
IF BMSize&<>&H28 THEN SHOWMESSAGE "BMP has wrong header size.":GOTO AbortLoadBMPgrey
File.Read(BMWidth&)
IF BMWidth&<>MustWidth% THEN SHOWMESSAGE "BMP isn't "+STR$(MustWidth%)+" pixels wide.":GOTO AbortLoadBMPgrey
File.Read(BMHeight&)
IF BMHeight&<>MustHeight% THEN SHOWMESSAGE "BMP isn't "+STR$(MustHeight%)+" pixels tall.":GOTO AbortLoadBMPgrey
File.Read(BMPlanes%)
IF BMPlanes%<>1 THEN SHOWMESSAGE "BMP has more than 1 plane.":GOTO AbortLoadBMPgrey
File.Read(BMBitCount%)
IF BMBitCount%<>8 THEN SHOWMESSAGE "BMP doesn't have an 8-bit color depth.":GOTO AbortLoadBMPgrey
File.Read(BMCompression&)
IF BMCompression&<>0 THEN SHOWMESSAGE "BMP isn't uncompressed.":GOTO AbortLoadBMPgrey
File.Read(BMImageSize&)
' IF BMImageSize&<>0  THEN SHOWMESSAGE "BMP size not set to 0.":GOTO AbortLoadBMPgrey
File.Read(BMXpixelsPerM&)
'IF BMXpixelsPerM&<>1 THEN SHOWMESSAGE "BMP horizontal resolution isn't 1 pixel/m.":GOTO AbortLoadBMPgrey
File.Read(BMYpixelsPerM&)
'IF BMYpixelsPerM&<>1 THEN SHOWMESSAGE "BMP vertical resolution isn't 1 pixel/m.":GOTO AbortLoadBMPgrey
File.Read(BMColorsUsed&)
'IF BMColorsUsed&<>&H1000000 THEN SHOWMESSAGE "BMP doesn't use 16 million colors.":GOTO AbortLoadBMPgrey
File.Read(BMColorsImportant&)
'IF BMColorsImportant&<>0 THEN SHOWMESSAGE "BMP has important colors set.":GOTO AbortLoadBMPgrey
BMColorTable$=File.ReadBinStr(1024)

Status1.SimpleText="Reading scanlines..."
Form1.Show
FOR X = 0 TO 127
File.LoadArray(SkyLight(127-X, 0),128)
NEXT X
StoreSkyLight
DrawSkyLight

Status1.SimpleText="Done"
AbortLoadBMPgrey:
Form1.Show
File.Close

END SUB



SUB ExportTGA_0
ExportTGA(0)
END SUB

SUB ImportTGA_0
ImportTGA(0)
END SUB

SUB ExportBMP16_0
ExportBMP16(0)
END SUB

SUB ImportBMP16_0
ImportBMP16(0)
END SUB

SUB ExportBMP32_0
ExportBMP32(0)
END SUB

SUB ImportBMP32_0
ImportBMP32(0)
END SUB

SUB ExportJPG_0
ExportJPG(0)
END SUB

SUB ImportJPG_0
ImportJPG(0)
END SUB


SUB ExportTGA_1
ExportTGA(1)
END SUB

SUB ImportTGA_1
ImportTGA(1)
END SUB

SUB ExportBMP16_1
ExportBMP16(1)
END SUB

SUB ImportBMP16_1
ImportBMP16(1)
END SUB

SUB ExportBMP32_1
ExportBMP32(1)
END SUB

SUB ImportBMP32_1
ImportBMP32(1)
END SUB

SUB ExportJPG_1
ExportJPG(1)
END SUB

SUB ImportJPG_1
ImportJPG(1)
END SUB


SUB ExportTGA_2
ExportTGA(2)
END SUB

SUB ImportTGA_2
ImportTGA(2)
END SUB

SUB ExportBMP16_2
ExportBMP16(2)
END SUB

SUB ImportBMP16_2
ImportBMP16(2)
END SUB

SUB ExportBMP32_2
ExportBMP32(2)
END SUB

SUB ImportBMP32_2
ImportBMP32(2)
END SUB

SUB ExportJPG_2
ExportJPG(2)
END SUB

SUB ImportJPG_2
ImportJPG(2)
END SUB


SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
    Canvas.Hint=""
    Canvas.Hint=STR$(X)+","+STR$(Y)
END SUB      

SUB CanvasPaint
DIM W AS INTEGER, H AS INTEGER
    W = Canvas.ClientWidth
    H = Canvas.ClientHeight
    Canvas.FillRect(0, 0, W, H, 0)

    CREATE RectArea as QRect
     Top=0
     Left=0
     Right=W
     Bottom=H
    END CREATE
    Canvas.Draw(0,0, Bitmap.BMP)
END SUB

SUB FileOpen
'  DIM OpenDialog AS QOpenDialog

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "RSC Files (*.rsc)|*.rsc"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Viewing "+FileName$
    LoadRscFile
'    ShowMenu.Enabled=True
      END IF
END SUB

SUB FileSave
'  DIM OpenDialog AS QOpenDialog

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "RSC Files (*.rsc)|*.rsc"

  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(LCASE$(FileName$),".rsc") = 0 THEN FileName$=FileName$+".rsc"
      Status1.SimpleText="Saving "+FileName$
    SaveRscFile
'    ShowMenu.Enabled=True
   END IF

END SUB
     


SUB ExitClick
  Form1.Close
END SUB  

SUB SelectSky(Sender AS QMENUITEM)
    Sender.Checked=1
    SkyIndex=Sender.menuIndex
    SELECT CASE SkyIndex
        CASE 0
        Status1.SimpleText="Dawn Sky"
        CASE 1
        Status1.SimpleText="Day Sky"
        CASE 2
        Status1.SimpleText="Night Sky"
        CASE ELSE
    END SELECT        
    DrawSky(SkyIndex)
    Form1.Show
END SUB


SUB SkyRGBto555(Z AS INTEGER)
DIM R AS INTEGER, D AS INTEGER
FOR X = 0 TO 255
FOR Y = 0 TO 255

R = SkyBitMap.Pixel(Y, X)

D=R

ROJO=INT((D AND &HF8)/8)
VERDE=INT((D AND &HF800)/&H800)
AZUL=(INT(D AND &HF80000)/&H80000)

D=(AZUL+VERDE*&H20+ROJO*&H400)

IF Z=0 THEN DawnSky(X, Y) = D
IF Z=1 THEN DaySky(X, Y) = D
IF Z=2 THEN NightSky(X, Y) = D

NEXT Y: NEXT X

END SUB


SUB DrawSky555(Z AS INTEGER)
DIM R AS INTEGER, D AS INTEGER
FOR X = 0 TO 255
FOR Y = 0 TO 255

IF Z=0 THEN R = DawnSky(X, Y)
IF Z=1 THEN R = DaySky(X, Y)
IF Z=2 THEN R = NightSky(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)

'H = Y: V = X + 256*Z
'H1 = Y + 1: V1 = X + 1 + 256*Z
'SkyList.Rectangle(H, V, H1, V1, D)
SkyList.Pixel(Y, X + 256*Z) = D

NEXT Y: NEXT X
END SUB

SUB DrawSky(Z AS INTEGER)
DIM SkyDestination AS QRECT
DIM SkySource AS QRECT
SkyCanvas.Visible = False

Form1.Color = 0

WITH SkyDestination
.Left = 0
.Right = 256
.Top = 0
.Bottom = 256
END WITH
WITH SkySource
.Left = 0
.Right = 256
.Top = 256*Z
.Bottom = .Top + 256
END WITH
SkyBitmap.CopyRect(SkyDestination, SkyList, SkySource)

SkyCanvas.Repaint
SkyCanvas.Visible = True
Form1.Show
END SUB


SUB SkyPaint
    SkyCanvas.Draw(0,0, SkyBitmap.BMP)
END SUB

SUB DrawSkyLight
SkyLightCanvas.Visible = False

Form1.Color = 0

SkyLightCanvas.Repaint
SkyLightCanvas.Visible = True
Form1.Show
END SUB

SUB StoreSkyLight
DIM R AS INTEGER, D AS INTEGER
FOR X = 0 TO 127
FOR Y = 0 TO 127

R = SkyLight(X, Y)
D=R*&H10101

'H = Y: V = X
'H1 = Y + 1: V1 = X + 1
'SkyLightBitMap.Rectangle(H, V, H1, V1, D)
SkyLightBitMap.Pixel(Y, X) = D

NEXT Y: NEXT X
END SUB

SUB SkyLightPaint
    SkyLightCanvas.Draw(0,0, SkyLightBitMap.BMP)
END SUB

SUB GreyscaleSkyLight
DIM R AS INTEGER, D AS INTEGER
FOR X = 0 TO 127
FOR Y = 0 TO 127
R = TEX??(X, Y)
D=R
ROJO=((D AND &H7C00)/&H400)*8
VERDE=((D AND &H03E0)/&H20)*8
AZUL=(D AND &H001F)*8
' Status1.SimpleText=STR$(ROJO)+","+STR$(VERDE)+","+STR$(AZUL)
' D=INT((AZUL*0.114+VERDE*0.587+ROJO*0.299)+0.5)
' D=INT((AZUL+VERDE*5+ROJO*2)/8)
' D=INT((AZUL*0.082+VERDE*0.6094+ROJO*0.3086))
' D=INT((AZUL*0.081+VERDE*0.419+ROJO*0.5))
' D=INT((AZUL*0.0721+VERDE*0.7154+ROJO*0.2125))
D=INT((AZUL*0.114+VERDE*0.587+ROJO*0.299))
' D=INT((AZUL*0.11+VERDE*0.59+ROJO*0.3))
' D=INT((AZUL+VERDE+ROJO)/3)
SkyLight(X, Y)=D
NEXT Y: NEXT X
END SUB

SUB SkyLightTo555
FOR X = 0 TO 127
FOR Y = 0 TO 127
TEX??(X, Y) = INT(SkyLight(X, Y)/8) * &H421
NEXT Y: NEXT X
END SUB

SUB SkyLightRGBto555
DIM R AS INTEGER, D AS INTEGER

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = SkyLightBitMap.Pixel(Y, X)

D=R

ROJO=INT((D AND &HF8)/8)
VERDE=INT((D AND &HF800)/&H800)
AZUL=(INT(D AND &HF80000)/&H80000)

D=(AZUL+VERDE*&H20+ROJO*&H400)

TEX??(X, Y) = D

NEXT Y: NEXT X

END SUB




SUB LoadRscFile

ShowMenu.Enabled=False
TextureMenu.Enabled=False
SkyMenu.Enabled=False
DawnMenu.Enabled=False
NightMenu.Enabled=False
SndMenu.Enabled=False
RndMenu.Enabled=False
AmbMenu.Enabled=False
FogMenu.Enabled=False
WaterMenu.Enabled=False
ObjMenu.Enabled=False
'ShowAnimList.Enabled=False
'ShowSfxList.Enabled=False

DIM File AS QFileStream
MapFile$=LEFT$(FileName$, RINSTR(FileName$,"."))+"map"
'PRINT MapFile$
IF FILEEXISTS(MapFile$)=0 THEN SHOWMESSAGE "Associated .map file not found!":GOTO AbortLoadRsc
File.Open(MapFile$, fmOpenRead)
IF File.Size=&H220000 THEN
    FileType=1
ELSE   
    IF File.Size=&HD80000 THEN
        FileType=2
    ELSE
        FileType=0
    END IF
END IF
'PRINT FileType
File.Close
IF FileType=0 THEN SHOWMESSAGE "Associated .map file doesn't seem to be a Carnivores file!": GOTO AbortLoadRsc
File.Open(FileName$, fmOpenRead)
'IF File.Size=&H220000 THEN
Status1.SimpleText="Reading Header Data..."
Form1.Show
File.Read(TexCount&)
File.Read(ObjCount&)

IF FileType=2 THEN
File.Read(DawnSkyR&)
File.Read(DawnSkyG&)
File.Read(DawnSkyB&)
END IF

File.Read(DaySkyR&)
File.Read(DaySkyG&)
File.Read(DaySkyB&)

IF FileType=2 THEN
File.Read(NightSkyR&)
File.Read(NightSkyG&)
File.Read(NightSkyB&)

File.Read(DawnSkyTR&)
File.Read(DawnSkyTG&)
File.Read(DawnSkyTB&)
END IF

File.Read(DaySkyTR&)
File.Read(DaySkyTG&)
File.Read(DaySkyTB&)

IF FileType=2 THEN
File.Read(NightSkyTR&)
File.Read(NightSkyTG&)
File.Read(NightSkyTB&)
END IF

'Form1.ClientWidth = 128
'Form1.ClientHeight = 128
Canvas.Width = 128
Canvas.Height = 128
Canvas.ClientWidth = 128
Canvas.ClientHeight = 128
BitMap.Width = 128
BitMap.Height = 128
'Form1.Center
TextureList.Height = 128*TexCount&
FOR CONTADOR=1 TO TexCount&
File.LoadArray(TEX??(0, 0),128*128)
'InitScreen
StoreBitmap(CONTADOR-1)
Status1.SimpleText="Texture #"+STR$(CONTADOR)+" of "+STR$(TexCount&)+" loaded"
Form1.Show
NEXT CONTADOR
ShowMenu.Enabled=True
TextureMenu.Enabled=True
SaveFile.Enabled=True
ExportPrj.Enabled=True
TexScrollSelect.Max=TexCount&-1
'ELSE
'Status1.SimpleText="Not a valid Carnivores .map file!"
'Form1.Show
'END IF    

DIM Frame AS INTEGER, Vertex AS INTEGER, Coord AS INTEGER
FOR CONTADOR=1 TO ObjCount&
File.ReadUDT(TMPObjInfo)
ObjsList(CONTADOR-1) = TMPObjInfo
File.LoadArray(PointList(CONTADOR-1,0,0),16*TMPObjInfo.VCount)
File.LoadArray(FaceList(CONTADOR-1,0,0),64*TMPObjInfo.FCount)
File.LoadArray(ObjList(CONTADOR-1,0,0),48*TMPObjInfo.OCount)
File.LoadArray(ObjTextures(CONTADOR-1,0,0),TMPObjInfo.TextureSize/2)
IF FileType = 2 THEN File.LoadArray(ObjSprites(CONTADOR-1,0,0),128*128)
IF TMPObjInfo.Flags AND &H80000000 THEN

File.Read(TMPvCount1)
File.Read(TMPvCount2)
File.Read(TMPaniKPS)
File.Read(TMPFramesCount)
AnimList(CONTADOR-1).vCount1=TMPvCount1
AnimList(CONTADOR-1).vCount2=TMPvCount2
AnimList(CONTADOR-1).aniKPS=TMPaniKPS
AnimList(CONTADOR-1).FramesCount=TMPFramesCount
TMPFramesCount++
TMPAniTime=(TMPFramesCount*1000)/TMPaniKPS
AnimList(CONTADOR-1).AniTime=TMPAniTime
 FOR Frame=1 to TMPFramesCount
  FOR Vertex=1 TO TMPvCount2
   FOR Coord=1 TO 3
    File.Read(TMPaniCoord)
    AnimData(CONTADOR-1,Frame-1,Vertex-1,Coord-1)=TMPaniCoord
   NEXT Coord
'  Status1.SimpleText="Data "+STR$(CONTADOR)+","+STR$(Frame)+","+STR$(Vertex)+"="+STR$(AnimData(A1-1,Frame-1,Vertex-1,0))+","+STR$(AnimData(A1-1,Frame-1,Vertex-1,1))+","+STR$(AnimData(A1-1,Frame-1,Vertex-1,2))
  NEXT Vertex
 NEXT Frame

END IF
Status1.SimpleText="Object #"+STR$(CONTADOR)+" of "+STR$(ObjCount&)+" loaded"
Form1.Show
NEXT CONTADOR

IF ObjCount&>0 THEN
ObjMenu.Enabled=True
ObjScrollSelect.Max=ObjCount&-1
END IF

IF FileType = 2 THEN File.LoadArray(DawnSky(0,0),256*256):Status1.SimpleText="Loading Dawn Sky":DawnMenu.Enabled=True:DrawSky555(0)
File.LoadArray(DaySky(0,0),256*256):Status1.SimpleText="Loading Day Sky":DayMenu.Checked=1:DrawSky555(1)
IF FileType = 2 THEN File.LoadArray(NightSky(0,0),256*256):Status1.SimpleText="Loading Night Sky":NightMenu.Enabled=True:DrawSky555(2)
File.LoadArray(SkyLight(0,0),128*128):Status1.SimpleText="Loading Sky Lightmap":StoreSkyLight
SkyMenu.Enabled=True

File.Read(FogCount&)
FOR CONTADOR=1 TO FogCount&
File.ReadUDT(FogsList(CONTADOR-1))
Status1.SimpleText="Fog #"+STR$(CONTADOR)+" of "+STR$(FogCount&)+" loaded"
Form1.Show
NEXT CONTADOR
FogScrollSelect.Max=FogCount&-1
FogMenu.Enabled=True

File.Read(RndCount&)
FOR CONTADOR = 1 TO RndCount&
Status1.SimpleText="Reading Random Sound #"+STR$(CONTADOR)+" of "+STR$(RndCount&)
Form1.Show
File.Read(TMPlength)
RndList(CONTADOR-1).length=TMPlength
Status1.SimpleText="Random Sound "+STR$(CONTADOR)+" of "+STR$(RndCount&)+" length: "+STR$(TMPlength)+" bytes read"
Form1.Show
TMPlpData=File.ReadBinStr(TMPlength)
RndList(CONTADOR-1).lpData = TMPlpData
' play (TMPlength, TMPlpData)
NEXT CONTADOR

IF RndCount&>0 THEN
    
RndScrollSelect.Max=RndCount&-1
    RndMenu.Enabled=True
'    ShowRndList.Enabled=True
    
END IF

File.Read(AmbCount&)
FOR CONTADOR = 1 TO AmbCount&
Status1.SimpleText="Reading Ambient Sound #"+STR$(CONTADOR)+" of "+STR$(AmbCount&)
Form1.Show
File.Read(TMPlength)
AmbList(CONTADOR-1).length=TMPlength
Status1.SimpleText="Ambient Sound "+STR$(CONTADOR)+" of "+STR$(AmbCount&)+" length: "+STR$(TMPlength)+" bytes read"
Form1.Show
TMPlpData=File.ReadBinStr(TMPlength)
AmbList(CONTADOR-1).lpData = TMPlpData
' play (TMPlength, TMPlpData)
FOR CONTADOR2 = 1 TO 16
File.ReadUDT(RndTable(CONTADOR-1,CONTADOR2-1))
NEXT CONTADOR2
File.ReadUDT(RndAmbient(CONTADOR-1))
Status1.SimpleText="Random Sound Table for Ambient Sound "+STR$(CONTADOR)+" of "+STR$(AmbCount&)+" loaded"
NEXT CONTADOR

IF AmbCount&>0 THEN
    

AmbScrollSelect.Max=AmbCount&-1
    AmbMenu.Enabled=True
    AmbSelect.Enabled=True
'    ShowAmbList.Enabled=True
    
END IF
    TblMenu.Enabled=True
    SndMenu.Enabled=True

IF FileType=2 THEN

File.Read(WtrCount&)
FOR CONTADOR=1 TO WtrCount&
File.ReadUDT(WaterList(CONTADOR-1))
Status1.SimpleText="Water #"+STR$(CONTADOR)+" of "+STR$(WtrCount&)+" read"
Form1.Show
NEXT CONTADOR

IF WtrCount&>0 THEN
WaterMenu.Enabled=True
WaterScrollSelect.Max=WtrCount&-1
WaterScrollTindex.Max=TexCount&-1
END IF

END IF

' RestOfFileSize=File.Size-File.Position
' RestOfFile=File.ReadBinStr(RestOfFileSize)
File.Close
' Indice=0
SkyIndex=1
FogIndex=0
WaterIndex=0
ObjIndex=0
TexIndex=0
RndIndex=0
TblIndex=0
TableScrollSelect.Max=AmbCount&-1
TableScrollSelect.Position=TblIndex
' InitTableForm
 FOR CONTADOR=0 TO 15
' Status1.SimpleText="Table entry "+STR$(CONTADOR+1)+" loading."
  TableScroll(CONTADOR).Max=RndCount&-1
' Status1.SimpleText="Table entry "+STR$(CONTADOR+1)+" loaded."
 NEXT CONTADOR
CALL DrawSkyLight
CALL DrawSky(SkyIndex)
'CALL DrawTexture(TexIndex)
TexPaint
Status1.SimpleText="File "+FileName$+" loaded."
' InitMesh
' ViewMesh
AbortLoadRsc:
END SUB

SUB StoreBitmap (Z AS INTEGER)
DIM R AS INTEGER, D AS INTEGER

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = TEX??(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)

'H = Y: V = X + 128*Z
'H1 = Y + 1: V1 = X + 1 + 128*Z
'TextureList.Rectangle(H, V, H1, V1, D)
'BitMap.Pset(H, V, D)
TextureList.Pixel(Y, X + 128*Z) = D


NEXT Y: NEXT X


END SUB

SUB InitScreen

Canvas.Visible = False

Form1.Color = 0

DrawPicture555
Canvas.Visible = True
' Canvas.Repaint
Canvas.ShowHint=True
TexPaint
END SUB


SUB DrawPicture555
DIM R AS INTEGER, D AS INTEGER


'BitMap.FillRect(0, 0, 128, 128, 0)

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = TEX??(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)

'H = Y: V = X
'H1 = Y + 1: V1 = X + 1
'BitMap.Rectangle(H, V, H1, V1, D)
'BitMap.Pset(H, V, D)
BitMap.Pixel(Y, X) = D


NEXT Y: NEXT X


END SUB


SUB RGBto555
DIM R AS INTEGER, D AS INTEGER

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = BitMap.Pixel(Y, X)

D=R

ROJO=INT((D AND &HF8)/8)
VERDE=INT((D AND &HF800)/&H800)
AZUL=(INT(D AND &HF80000)/&H80000)

D=(AZUL+VERDE*&H20+ROJO*&H400)

TEX??(X, Y) = D

NEXT Y: NEXT X

END SUB


SUB RetrieveBitmap (Z AS INTEGER)
DIM R AS INTEGER, D AS INTEGER

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = TextureList.Pixel(Y, X + 128*Z)

D=R

ROJO=INT((D AND &HF8)/8)
VERDE=INT((D AND &HF800)/&H800)
AZUL=(INT(D AND &HF80000)/&H80000)

D=(AZUL+VERDE*&H20+ROJO*&H400)

TEX??(X, Y) = D

NEXT Y: NEXT X


END SUB


SUB SaveRscFile

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
'IF File.Size=&H220000 THEN
Status1.SimpleText="Writing Header Data..."
Form1.Show
File.Write(TexCount&)
File.Write(ObjCount&)

IF FileType=2 THEN
File.Write(DawnSkyR&)
File.Write(DawnSkyG&)
File.Write(DawnSkyB&)
END IF

File.Write(DaySkyR&)
File.Write(DaySkyG&)
File.Write(DaySkyB&)

IF FileType=2 THEN
File.Write(NightSkyR&)
File.Write(NightSkyG&)
File.Write(NightSkyB&)

File.Write(DawnSkyTR&)
File.Write(DawnSkyTG&)
File.Write(DawnSkyTB&)
END IF

File.Write(DaySkyTR&)
File.Write(DaySkyTG&)
File.Write(DaySkyTB&)

IF FileType=2 THEN
File.Write(NightSkyTR&)
File.Write(NightSkyTG&)
File.Write(NightSkyTB&)
END IF

FOR CONTADOR=1 TO TexCount&
RetrieveBitmap(CONTADOR-1)
File.SaveArray(TEX??(0, 0),128*128)
'InitScreen
Status1.SimpleText="Texture #"+STR$(CONTADOR)+" of "+STR$(TexCount&)+" saved"
Form1.Show
NEXT CONTADOR

DIM Frame AS INTEGER, Vertex AS INTEGER, Coord AS INTEGER
FOR CONTADOR=1 TO ObjCount&
TMPObjInfo = ObjsList(CONTADOR-1)
File.WriteUDT(TMPObjInfo)
File.SaveArray(PointList(CONTADOR-1,0,0),16*TMPObjInfo.VCount)
File.SaveArray(FaceList(CONTADOR-1,0,0),64*TMPObjInfo.FCount)
File.SaveArray(ObjList(CONTADOR-1,0,0),48*TMPObjInfo.OCount)
File.SaveArray(ObjTextures(CONTADOR-1,0,0),TMPObjInfo.TextureSize/2)
IF FileType = 2 THEN File.SaveArray(ObjSprites(CONTADOR-1,0,0),128*128)
IF TMPObjInfo.Flags AND &H80000000 THEN

TMPvCount1=AnimList(CONTADOR-1).vCount1
TMPvCount2=AnimList(CONTADOR-1).vCount2
TMPaniKPS=AnimList(CONTADOR-1).aniKPS
TMPFramesCount=AnimList(CONTADOR-1).FramesCount
File.Write(TMPvCount1)
File.Write(TMPvCount2)
File.Write(TMPaniKPS)
File.Write(TMPFramesCount)
TMPFramesCount++
 FOR Frame=1 to TMPFramesCount
  FOR Vertex=1 TO TMPvCount2
   FOR Coord=1 TO 3
    TMPaniCoord=AnimData(CONTADOR-1,Frame-1,Vertex-1,Coord-1)
    File.Write(TMPaniCoord)
   NEXT Coord
'  Status1.SimpleText="Data "+STR$(CONTADOR)+","+STR$(Frame)+","+STR$(Vertex)+"="+STR$(AnimData(A1-1,Frame-1,Vertex-1,0))+","+STR$(AnimData(A1-1,Frame-1,Vertex-1,1))+","+STR$(AnimData(A1-1,Frame-1,Vertex-1,2))
  NEXT Vertex
 NEXT Frame

END IF
Status1.SimpleText="Object #"+STR$(CONTADOR)+" of "+STR$(ObjCount&)+" saved"
Form1.Show
NEXT CONTADOR

IF FileType = 2 THEN File.SaveArray(DawnSky(0,0),256*256):Status1.SimpleText="Dawn Sky saved"
File.SaveArray(DaySky(0,0),256*256):Status1.SimpleText="Day Sky saved"
IF FileType = 2 THEN File.SaveArray(NightSky(0,0),256*256):Status1.SimpleText="Night Sky saved"
File.SaveArray(SkyLight(0,0),128*128):Status1.SimpleText="Sky Lightmap saved"

File.Write(FogCount&)
FOR CONTADOR=1 TO FogCount&
File.WriteUDT(FogsList(CONTADOR-1))
Status1.SimpleText="Fog #"+STR$(CONTADOR)+" of "+STR$(FogCount&)+" saved"
Form1.Show
NEXT CONTADOR

File.Write(RndCount&)
FOR CONTADOR = 1 TO RndCount&
Status1.SimpleText="Writing Random Sound #"+STR$(CONTADOR)+" of "+STR$(RndCount&)
Form1.Show
TMPlength=RndList(CONTADOR-1).length
File.Write(TMPlength)
Status1.SimpleText="Random Sound "+STR$(CONTADOR)+" of "+STR$(RndCount&)+" length: "+STR$(TMPlength)+" bytes written"
Form1.Show
TMPlpData = RndList(CONTADOR-1).lpData
File.WriteBinStr(TMPlpData,TMPlength)
' play (TMPlength, TMPlpData)
NEXT CONTADOR

File.Write(AmbCount&)
FOR CONTADOR = 1 TO AmbCount&
Status1.SimpleText="Writing Ambient Sound #"+STR$(CONTADOR)+" of "+STR$(AmbCount&)
Form1.Show
TMPlength=AmbList(CONTADOR-1).length
File.Write(TMPlength)
Status1.SimpleText="Ambient Sound "+STR$(CONTADOR)+" of "+STR$(AmbCount&)+" length: "+STR$(TMPlength)+" bytes written"
Form1.Show
TMPlpData = AmbList(CONTADOR-1).lpData
File.WriteBinStr(TMPlpData,TMPlength)
' play (TMPlength, TMPlpData)
FOR CONTADOR2 = 1 TO 16
File.WriteUDT(RndTable(CONTADOR-1,CONTADOR2-1))
NEXT CONTADOR2
File.WriteUDT(RndAmbient(CONTADOR-1))
Status1.SimpleText="Random Sound Table for Ambient Sound "+STR$(CONTADOR)+" of "+STR$(AmbCount&)+" saved"
NEXT CONTADOR

IF FileType=2 THEN

File.Write(WtrCount&)
FOR CONTADOR=1 TO WtrCount&
File.WriteUDT(WaterList(CONTADOR-1))
Status1.SimpleText="Water #"+STR$(CONTADOR)+" of "+STR$(WtrCount&)+" saved"
Form1.Show
NEXT CONTADOR

END IF
' File.WriteBinStr(RestOfFile,RestOfFileSize)
Status1.SimpleText="File "+FileName$+" saved."
AbortSaveRsc:
File.Close
END SUB

SUB FilePrjExport
  
  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "Project Files (*.prj)|*.prj"

  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(LCASE$(FileName$),".prj") = 0 THEN FileName$=FileName$+".prj"
    Status1.SimpleText="Exporting as "+FileName$
    SavePrjFile
'    ShowMenu.Enabled=True
   END IF
END SUB

SUB SavePrjFile

DIM File AS QFileStream
File.Open(FileName$, fmCreate)

IF FileType=2 THEN
File.Write("Version=6"+LF)
END IF

Status1.SimpleText="Writing Texture Data..."
Form1.Show
File.Write("Total textures="+STR$(TexCount&)+LF)

FOR CONTADOR=1 TO TexCount&
File.Write("Texture"+RIGHT$("000"+STR$(CONTADOR),3)+"=Texture"+RIGHT$("000"+STR$(CONTADOR),3)+LF)
NEXT CONTADOR
Status1.SimpleText="Textures: "+STR$(TexCount&)
Form1.Show

Status1.SimpleText="Writing Object Data..."
Form1.Show
File.Write("Total objects="+STR$(ObjCount&)+LF)

FOR CONTADOR=1 TO ObjCount&
File.Write("Object"+RIGHT$("000"+STR$(CONTADOR),3)+"=Object"+RIGHT$("000"+STR$(CONTADOR),3)+LF)
NEXT CONTADOR
Status1.SimpleText="Objects: "+STR$(ObjCount&)
Form1.Show

File.Write("Sky loaded=1"+LF)
File.Write("Sky map loaded=1"+LF)

IF FileType=1 THEN
File.Write("Version=2"+LF)
END IF

Status1.SimpleText="Writing Fog Data..."
Form1.Show
File.Write("Total fog="+STR$(FogCount&)+LF)

FOR CONTADOR=1 TO FogCount&
File.Write("Fog"+RIGHT$("000"+STR$(CONTADOR),3)+"=Fog"+RIGHT$("000"+STR$(CONTADOR),3)+LF)
NEXT CONTADOR
Status1.SimpleText="Fogs: "+STR$(FogCount&)
Form1.Show

Status1.SimpleText="Writing Random Sound Data..."
Form1.Show
File.Write("Total random sound="+STR$(RndCount&)+LF)

FOR CONTADOR=1 TO RndCount&
File.Write("Random"+RIGHT$("000"+STR$(CONTADOR),3)+"=Random"+RIGHT$("000"+STR$(CONTADOR),3)+LF)
NEXT CONTADOR
Status1.SimpleText="Random sounds: "+STR$(RndCount&)
Form1.Show

Status1.SimpleText="Writing Ambient Sound Data..."
Form1.Show
File.Write("Total ambient sound="+STR$(AmbCount&)+LF)

FOR CONTADOR=1 TO AmbCount&
File.Write("Ambient"+RIGHT$("000"+STR$(CONTADOR),3)+"=Ambient"+RIGHT$("000"+STR$(CONTADOR),3)+LF)
NEXT CONTADOR
Status1.SimpleText="Ambient sounds: "+STR$(AmbCount&)
Form1.Show



    Status1.SimpleText="Project file saved successfully as "+FileName$+"."
File.Close
END SUB

' SUB PlaySfx
'     TMPsfxName=RndList(SfxIndex).sfxName
'     TMPlength=RndList(SfxIndex).length
'     TMPlpData=RndList(SfxIndex).lpData
'     Status1.SimpleText="Playing sound "+STR$(SfxIndex+1)
'     play (TMPlength, TMPlpData)
' END SUB

sub play (length AS INTEGER, wavdata AS STRING)
'	doevents

	'## stop sound and delete it
	playsound(0, 0, 0)
	soundstream.close

	soundstream.writestr("RIFF", 4) '## indicates wave file header chunk
	soundstream.writenum(length+36, 4) '## total length of package to follow, 4 bytes

	soundstream.writestr("WAVE", 4)

	soundstream.writestr("fmt ", 4) '## begin format chunk
	soundstream.writenum(16, 4)     '## length of format chunk
	soundstream.writenum(1,  2)     '## WAVE_FORMAT_PCM
	soundstream.writenum(1,  2)     '## channels 1-mono 2-stereo
	soundstream.writenum(22050,  4) '## sample rate in Hz
	soundstream.writenum(44100,  4) '## bytes per second (samplerate * channels * bytespersample)
	soundstream.writenum(2,  2)     '## bytes per sample
	soundstream.writenum(16, 2)     '## bits per sample

	soundstream.writestr("data", 4) '## begin data chunk
	soundstream.writenum(length, 4) '## length of data to follow
	soundstream.writestr(wavdata, length) '## wave data
	'## play from memory
	playsound(soundstream.pointer, 0, 4) '## SND_ASYNC=1, SND_MEMORY=4
end sub

sub saveWav (fn AS STRING, length AS INTEGER, wavdata AS STRING)
'	doevents

'      WavFile.close
      WavFile.Open(fn, fmCreate)

	WavFile.writestr("RIFF", 4) '## indicates wave file header chunk
	WavFile.writenum(length+36, 4) '## total length of package to follow, 4 bytes

	WavFile.writestr("WAVE", 4)

	WavFile.writestr("fmt ", 4) '## begin format chunk
	WavFile.writenum(16, 4)     '## length of format chunk
	WavFile.writenum(1,  2)     '## WAVE_FORMAT_PCM
	WavFile.writenum(1,  2)     '## channels 1-mono 2-stereo
	WavFile.writenum(22050,  4) '## sample rate in Hz
	WavFile.writenum(44100,  4) '## bytes per second (samplerate * channels * bytespersample)
	WavFile.writenum(2,  2)     '## bytes per sample
	WavFile.writenum(16, 2)     '## bits per sample

	WavFile.writestr("data", 4) '## begin data chunk
	WavFile.writenum(length, 4) '## length of data to follow
	WavFile.writestr(wavdata, length) '## wave data
      WavFile.close
end sub

sub loadWav (fn AS STRING, SoundType AS INTEGER)
'	doevents

'      WavFile.close
	DIM wavChunkID$ AS STRING * 4
      DIM wavChunkSize&
	DIM wavFormat$ AS STRING * 4
	DIM wavSubchunk1ID$ AS STRING * 4
      DIM wavSubchunk1Size&
      DIM wavAudioFormat%
      DIM wavNumChannels%
      DIM wavSampleRate&
      DIM wavByteRate&
      DIM wavBlockAlign%
      DIM wavBitsPerSample%
	DIM wavSubchunk2ID$ AS STRING * 4
            DIM factSubchunkID$ AS STRING * 4
            DIM factSubchunkSize&
            DIM wavSampleLength&
            DIM wavFactSubChunk$ AS STRING * factSubchunkSize&
      DIM wavSubchunk2Size&
     	DIM wavData$ AS STRING * wavSubchunk2Size&

      WavFile.Open(fn, fmOpenRead)

	wavChunkID$=WavFile.readstr(4) '## indicates wave file header chunk
      IF LEFT$(wavChunkID$,4)<>"RIFF" THEN SHOWMESSAGE "Not a RIFF file.":GOTO AbortLoadWav
      wavChunkSize&=WavFile.readnum(4) '## total length of package to follow, 4 bytes
      IF wavChunkSize&<>WavFile.Size-8 THEN SHOWMESSAGE "Filesize mismatch.":GOTO AbortLoadWav
	wavFormat$=WavFile.readstr(4) '## indicates wave format
      IF LEFT$(wavFormat$,4)<>"WAVE" THEN SHOWMESSAGE "Not a WAVE format file.":GOTO AbortLoadWav
	wavSubchunk1ID$=WavFile.readstr(4) '## begin format chunk
      IF LEFT$(wavSubchunk1ID$,4)<>"fmt " THEN SHOWMESSAGE "Format subchunk not found.":GOTO AbortLoadWav
      wavSubchunk1Size&=WavFile.readnum(4) '## length of format chunk
      IF wavSubchunk1Size&<>16 THEN SHOWMESSAGE "Incorrect subchunk size.":GOTO AbortLoadWav
      wavAudioFormat%=WavFile.readnum(2) '## WAVE_FORMAT_PCM
      IF wavAudioFormat%<>1 THEN SHOWMESSAGE "Not a PCM format wavefile.":GOTO AbortLoadWav
      wavNumChannels%=WavFile.readnum(2) '## channels 1-mono 2-stereo
      IF wavNumChannels%<>1 THEN SHOWMESSAGE "Not a single-channel wavefile.":GOTO AbortLoadWav
      wavSampleRate&=WavFile.readnum(4) '## sample rate in Hz
      IF wavSampleRate&<>22050 THEN SHOWMESSAGE "Not a 22050Hz sample rate.":GOTO AbortLoadWav
      wavByteRate&=WavFile.readnum(4) '## bytes per second (samplerate * channels * bytespersample)
      IF wavByteRate&<>44100 THEN SHOWMESSAGE "Not a 44100 bytes per second rate.":GOTO AbortLoadWav
            wavBlockAlign%=WavFile.readnum(2) '## bytes per sample
      IF wavBlockAlign%<>2 THEN SHOWMESSAGE "Not a 2 bytes per sample size.":GOTO AbortLoadWav
      wavBitsPerSample%=WavFile.readnum(2) '## bits per sample
      IF wavBitsPerSample%<>16 THEN SHOWMESSAGE "Not a 16 bits per sample size.":GOTO AbortLoadWav
	wavSubchunk2ID$=WavFile.readstr(4) '## begin data chunk or fact chunk
      IF LEFT$(wavSubchunk2ID$,4)<>"data" THEN
            factSubchunkID$=wavSubchunk2ID$
            IF LEFT$(factSubchunkID$,4)<>"fact" THEN SHOWMESSAGE "Not a Data of Fact subchunk.":GOTO AbortLoadWav
            factSubchunkSize&=WavFile.readnum(4) '## total length of package to follow, at least 4 bytes
'            IF factSubchunkSize&<>4 THEN SHOWMESSAGE "Incorrect fact subchunk size.":GOTO AbortLoadWav
'            wavSampleLength&=WavFile.readnum(4) '## number of samples per channel
            wavFactSubChunk$=WavFile.readstr(factSubchunkSize&) '## ignore this block (shouldn't even be there in the first place)
            wavSubchunk2ID$=WavFile.readstr(4) '## begin data chunk
            IF LEFT$(wavSubchunk2ID$,4)<>"data" THEN SHOWMESSAGE "Data subchunk not found.":GOTO AbortLoadWav
      END IF
      wavSubchunk2Size&=WavFile.readnum(4) '## length of data to follow
'      IF wavSubchunk2Size&<>WavFile.Size-44 AND wavSubchunk2Size&<>WavFile.Size-56 THEN SHOWMESSAGE "Incorrect data size.":GOTO AbortLoadWav
      IF wavSubchunk2Size&>WavFile.Size-WavFile.Position THEN SHOWMESSAGE "Incorrect data size.":GOTO AbortLoadWav
	wavData$=WavFile.readstr(wavSubchunk2Size&) '## wave data
SELECT CASE SoundType
    CASE 0
        RndList(RndIndex).length=wavSubchunk2Size&
        RndList(RndIndex).lpData=wavData$
        Status1.SimpleText="Replaced random sound "+STR$(RndIndex)
    CASE 1
        AmbList(AmbIndex).length=wavSubchunk2Size&
        AmbList(AmbIndex).lpData=wavData$
        Status1.SimpleText="Replaced ambient sound "+STR$(AmbIndex)
    CASE ELSE
END SELECT
AbortLoadWav:
    WavFile.close
end sub

SUB Obj1Save
  
  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
'  IF FileType=1 THEN SaveDialog.Filter = "Carnivores 1 object Files (*.c1o)|*.c1o"
'  IF FileType=2 THEN SaveDialog.Filter = "Carnivores 2/Ice Age object Files (*.c2o)|*.c2o"
'  SaveDialog.Filter = "Carnivores 1 object Files (*.c1o)|*.c1o|Carnivores 2/Ice Age object Files (*.c2o)|*.c2o"
  SaveDialog.Filter = "Carnivores 1 object Files (*.c1o)|*.c1o"
    ObjType=1
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
    IF INSTR(LCASE$(FileName$),".c1o") = 0 THEN FileName$=FileName$+".c1o"
'    IF ObjType=2 AND INSTR(LCASE$(FileName$),".c2o") = 0 THEN FileName$=FileName$+".c2o"
    Status1.SimpleText="Saving "+FileName$
    SaveObjFile
'    ShowMenu.Enabled=True
   END IF
END SUB

SUB Obj2Save
  
  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
'  IF FileType=1 THEN SaveDialog.Filter = "Carnivores 1 object Files (*.c1o)|*.c1o"
'  IF FileType=2 THEN SaveDialog.Filter = "Carnivores 2/Ice Age object Files (*.c2o)|*.c2o"
  SaveDialog.Filter = "Carnivores 2/Ice Age object Files (*.c2o)|*.c2o"
    ObjType=2
  IF SaveDialog.Execute THEN
'    ObjType=SaveDialog.FilterIndex
    FileName$=SaveDialog.FileName
'    IF ObjType=1 AND INSTR(LCASE$(FileName$),".c1o") = 0 THEN FileName$=FileName$+".c1o"
    IF INSTR(LCASE$(FileName$),".c2o") = 0 THEN FileName$=FileName$+".c2o"
    Status1.SimpleText="Saving "+FileName$
    SaveObjFile
'    ShowMenu.Enabled=True
   END IF
END SUB

SUB SaveObjFile
DIM Frame AS INTEGER, Vertex AS INTEGER, Coord AS INTEGER

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header Data..."
Form1.Show
TMPObjInfo = ObjsList(ObjIndex)
 IF FileType=1 AND ObjType=2 THEN TMPObjInfo.Flags=(TMPObjInfo.Flags OR &H20)
File.WriteUDT(TMPObjInfo)
Status1.SimpleText="Writing vertices..."
Form1.Show
File.SaveArray(PointList(ObjIndex,0,0),16*TMPObjInfo.VCount)
Status1.SimpleText="Writing faces..."
Form1.Show
File.SaveArray(FaceList(ObjIndex,0,0),64*TMPObjInfo.FCount)
Status1.SimpleText="Writing objects..."
Form1.Show
File.SaveArray(ObjList(ObjIndex,0,0),48*TMPObjInfo.OCount)
Status1.SimpleText="Writing texture..."
Form1.Show
File.SaveArray(ObjTextures(ObjIndex,0,0),TMPObjInfo.TextureSize/2)
IF ObjType=2 THEN
Status1.SimpleText="Writing sprite..."
Form1.Show
 File.SaveArray(ObjSprites(ObjIndex,0,0),128*128)
END IF
IF TMPObjInfo.Flags AND &H80000000 THEN
Status1.SimpleText="Writing animation..."
Form1.Show

TMPvCount1=AnimList(ObjIndex).vCount1
TMPvCount2=AnimList(ObjIndex).vCount2
TMPaniKPS=AnimList(ObjIndex).aniKPS
TMPFramesCount=AnimList(ObjIndex).FramesCount
File.Write(TMPvCount1)
File.Write(TMPvCount2)
File.Write(TMPaniKPS)
File.Write(TMPFramesCount)
TMPFramesCount++
 FOR Frame=1 to TMPFramesCount
  FOR Vertex=1 TO TMPvCount2
   FOR Coord=1 TO 3
    TMPaniCoord=AnimData(ObjIndex,Frame-1,Vertex-1,Coord-1)
    File.Write(TMPaniCoord)
   NEXT Coord
  NEXT Vertex
 NEXT Frame
END IF

    Status1.SimpleText=FileName$+" saved OK."
File.Close
END SUB

SUB ObjLoad
    OpenDialog.InitialDir = CurDir$
    OpenDialog.Filter = "Carnivores 1 object Files (*.c1o)|*.c1o|Carnivores 2/Ice Age object Files (*.c2o)|*.c2o"

    IF OpenDialog.Execute THEN
        ObjType=OpenDialog.FilterIndex
        FileName$=OpenDialog.FileName
        Status1.SimpleText="Loading "+FileName$
        LoadObjFile
    END IF
END SUB

SUB LoadObjFile
DIM Frame AS INTEGER, Vertex AS INTEGER, Coord AS INTEGER

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
Status1.SimpleText="Reading Header Data..."
Form1.Show
File.ReadUDT(TMPObjInfo)
 IF FileType=1 AND ObjType=2 THEN TMPObjInfo.Flags=(TMPObjInfo.Flags AND &HFFFFFFDF)
ObjsList(ObjIndex) = TMPObjInfo
Status1.SimpleText="Reading vertices..."
Form1.Show
File.LoadArray(PointList(ObjIndex,0,0),16*TMPObjInfo.VCount)
Status1.SimpleText="Reading faces..."
Form1.Show
File.LoadArray(FaceList(ObjIndex,0,0),64*TMPObjInfo.FCount)
Status1.SimpleText="Reading objects..."
Form1.Show
File.LoadArray(ObjList(ObjIndex,0,0),48*TMPObjInfo.OCount)
Status1.SimpleText="Reading texture..."
Form1.Show
File.LoadArray(ObjTextures(ObjIndex,0,0),TMPObjInfo.TextureSize/2)
IF ObjType=2 THEN
Status1.SimpleText="Reading sprite..."
Form1.Show
 File.LoadArray(ObjSprites(ObjIndex,0,0),128*128)
END IF
IF TMPObjInfo.Flags AND &H80000000 THEN
Status1.SimpleText="Reading animation..."
Form1.Show

File.Read(TMPvCount1)
File.Read(TMPvCount2)
File.Read(TMPaniKPS)
File.Read(TMPFramesCount)
AnimList(ObjIndex).vCount1=TMPvCount1
AnimList(ObjIndex).vCount2=TMPvCount2
AnimList(ObjIndex).aniKPS=TMPaniKPS
AnimList(ObjIndex).FramesCount=TMPFramesCount
TMPFramesCount++
 FOR Frame=1 to TMPFramesCount
  FOR Vertex=1 TO TMPvCount2
   FOR Coord=1 TO 3
    File.Read(TMPaniCoord)
    AnimData(ObjIndex,Frame-1,Vertex-1,Coord-1)=TMPaniCoord
   NEXT Coord
  NEXT Vertex
 NEXT Frame
END IF

    Status1.SimpleText=FileName$+" loaded OK."
File.Close
END SUB


sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
    dx = ox - nx
    dy = ny - oy
    select case state
      case PAN:    trans(0) = trans(0) - dx
                   trans(1) = trans(1) - dy
      case ROTATE: rotat(0) = rotat(0) + (dy * 18.0) / 10.0
                   rotat(1) = rotat(1) - (dx * 18.0) / 10.0
      case ZOOM:   trans(2) = trans(2) - (dx + dy) 
    end select
end sub

sub setrendermode
    	'' All Setup For OpenGL Goes Here 
''	glEnable GL_TEXTURE_2D                         '' Enable Texture Mapping ( NEW ) 
    glEnable(GL_DEPTH_TEST)
    glDepthFunc(GL_LEQUAL)
    glEnable (GL_CULL_FACE)
    glCullFace (GL_FRONT)
end sub

sub setvisual(iw as integer, ih as integer)
    defdbl aspect = iw/ih
    glViewport(0, 0, iw, ih)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity
    gluPerspective(60.0,aspect,0.1,3000.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity
    glTranslatef(0.0, 0.0, -100.0)
end sub

sub meshbuilder
    ' rotate a triangle around 
'     glMatrixMode (GL_MODELVIEW)
    glPushMatrix
    glTranslatef(trans(0), trans(1), trans(2))
    glRotatef(rotat(0), 1.0, 0.0, 0.0)
    glRotatef(rotat(1), 0.0, 1.0, 0.0)
        glClearColor(0.0,0.0,0.0,0.0)
        glClearDepth(1.0)
    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)
        glPolygonMode(GL_FRONT_AND_BACK, GL_LINE)
        glDisable(GL_CULL_FACE)
glCallList(meshList)
    glPopMatrix
'    glMatrixMode (GL_MODELVIEW)
    GL.Flip
end sub


SUB FormMouseDown (Button%, X%, Y%, Shift%) 
  if Button% = 0 then state = ROTATE  'or state 
  if Button%= 1 then state = PAN 'or state 
  if Button%= 2 then state = ZOOM 'or state 
  mx = X%'Screen.mouseX 
  my = Y%'Screen.mouseY 
END SUB

SUB FormMouseUp(Button%, X%, Y%, Shift%)
   state = 0
END SUB

SUB FormMouseMove (X%, Y%, Shift%)
     meshframe(state, mx, X%, my, Y%)
     mx = X%
     my = y%
     meshbuilder
     GL.Flip
END SUB

SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER) 
'  if key = 27 then 
'    GL.Close
'    ObjForm.close
'  end if
'  if KeyShift THEN state = STATE XOR ZOOM
  SELECT CASE Key
  CASE 33 ' Page Up
  state = ZOOM
  meshframe(state,0,2,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 34 ' Page Down
  state = ZOOM
  meshframe(state,2,0,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 37 ' Left Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,2,0,0,0)
     meshbuilder
  state = 0
       GL.Flip
  CASE 38 ' Up Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,2,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 39 ' Right Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,2,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 40 ' Down Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,0,2)
     meshbuilder
  state = 0
       GL.Flip
  CASE ELSE
  state = 0
  meshframe(state,0,0,0,0)
     meshbuilder
     GL.Flip
  END SELECT
END SUB


SUB FormSize
  GL.Resize(form.clientWidth, form.clientHeight)
'  GL.Resize(256, 256)
  setvisual(GL.width, GL.height)
'  setvisual(256, 256)
  meshbuilder
END SUB
 
 
SUB ViewMesh
'GL.Init(Form)
FormSize
Form.Show
    Form.Left=Form1.Left+264
    Form.Top=Form1.Top
END SUB


SUB FormCreate
    GL.Init(Form)
   setrendermode
        glClearColor(0.0,0.0,0.0,0.0)
        glClearDepth(1.0)
    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)
'   ViewMesh
END SUB

SUB FormClose
'    Form.close
END SUB


SUB ObjNumberChange
    ObjIndex=ObjScrollSelect.Position
    ObjLabelNum0.Caption = STR$(ObjIndex)
'    InitMesh
'    meshbuilder
END SUB


SUB EditObjForm
    ObjScrollSelect.Position=ObjIndex
    ObjForm.Visible=True
'    InitMesh
'    meshbuilder
'    ViewMesh
'    ObjForm.Show
END SUB

SUB TexNumberChange
    TexIndex=TexScrollSelect.Position
    TexLabelNum0.Caption = STR$(TexIndex)
    TexPaint
END SUB


SUB EditTexForm
    TexScrollSelect.Position=TexIndex
    TexForm.Visible=True
END SUB

SUB CloseTexForm
    TexForm.Close
END SUB

SUB TexPaint
DIM Destination AS QRECT
DIM Source AS QRECT
DIM Z AS INTEGER                     
Z=TexIndex
WITH Destination
.Left = 0
.Right = 128
.Top = 0
.Bottom = 128
END WITH
WITH Source
.Left = 0
.Right = 128
.Top = 128*Z
.Bottom = .Top + 128
END WITH
TextureBox.CopyRect(Destination, TextureList, Source)

END SUB

SUB RndNumberChange
    RndIndex=RndScrollSelect.Position
    RndLabelNum0.Caption = STR$(RndIndex)
END SUB

SUB EditRndForm
    RndScrollSelect.Position=RndIndex
    RndForm.Visible=True
END SUB

SUB CloseRndForm
    RndForm.Close
END SUB

SUB AmbNumberChange
    AmbIndex=AmbScrollSelect.Position
    AmbLabelNum0.Caption = STR$(AmbIndex)
END SUB

SUB EditAmbForm
    AmbScrollSelect.Position=AmbIndex
    AmbForm.Visible=True
END SUB

SUB CloseAmbForm
    AmbForm.Close
END SUB

